#module
#uselib "dsmultiwave.dll"
#cfunc global initdsound "InitDSound" int
#cfunc global initsoundbuffer "InitSoundBuffer" wptr
#func global psound0play "pSound0Play" int,int,int
#func global psound0reset "pSound0Reset" int
#func global psound0stop "pSound0Stop" int
#func global releasesoundbuffer "ReleaseSoundBuffer" int
#func global releasedsound "ReleaseDSound"
#const global Maxngroup 200
#const global Maxnplayer 20
#const global Bx20z1 0
#const global Bx2z10 1
#const global Bx1z20 2
#const global Bx4z5 3
#const global Bx10z2 4
#const global Blx23456z5 5
#const global Blx65432z5 6
#const global Brx23456z5 7
#const global Brx65432z5 8

#deffunc waitbyfps int p1, var fps
	E3DWaitbyFPS@ p1, fps
	await 0
	return

#deffunc cameraangleroundxz double degstep
	x = camposx@ - camtargetposx@
	y = camposy@ - camtargetposy@
	z = camposz@ - camtargetposz@
	
	;E3DVec3Length x,y,z,r
	E3DVec3Length@ x,0.0,z,r0
	theta0 = atan(z,x)
	
	theta0 += degstep
	x = r0 * cos(theta0)
	z = r0 * sin(theta0)
	camposx@ = camtargetposx@ + x
	camposz@ = camtargetposz@ + z
	
	E3DSetCameraPos@ camposx@, camposy@, camposz@
	E3DSetCameraTarget@ camtargetposx@,camtargetposy@,camtargetposz@, 0.0, 1.0, 0.0
	return

#deffunc cameraangleroundy double degstep
	x = camposx@ - camtargetposx@
	y = camposy@ - camtargetposy@
	z = camposz@ - camtargetposz@
	
	E3DVec3Length@ x,y,z,r
	E3DVec3Length@ x,0.0,z,r0
	theta = atan(y,r0)
	phi = atan(z,x)
	xmax = r * cos(phi)
	zmax = r * sin(phi)
	
	theta += degstep
	;if theta >= 2.0 * M_PI : theta -= 2.0 * M_PI
	;r0 = r * cos(theta)
	y = r * sin(theta)
	x = xmax * cos(theta)
	z = zmax * cos(theta)
	camposx@ = camtargetposx@ + x
	camposy@ = camtargetposy@ + y
	camposz@ = camtargetposz@ + z
	
	E3DSetCameraPos@ camposx@, camposy@, camposz@
	E3DSetCameraTarget@ camtargetposx@,camtargetposy@,camtargetposz@,upvecx@,upvecy@,upvecz@
	return
	
#deffunc cameratargetroundxz double degstep
	x = camtargetposx@ - camposx@
	y = camtargetposy@ - camposy@
	z = camtargetposz@ - camposz@
	
	E3DVec3Length@ x,0.0,z,r0
	theta0 = atan(z,x)
	
	theta0 += degstep
	x = r0 * cos(theta0)
	z = r0 * sin(theta0)
	camtargetposx@ = camposx@ + x
	camtargetposz@ = camposz@ + z
	
	E3DSetCameraPos@ camposx@, camposy@, camposz@
	E3DSetCameraTarget@ camtargetposx@,camtargetposy@,camtargetposz@, 0.0, 1.0, 0.0
	return

#deffunc cameratargetroundy double degstep
	x = camtargetposx@ - camposx@
	y = camtargetposy@ - camposy@
	z = camtargetposz@ - camposz@
	
	E3DVec3Length@ x,0.0,z,r0
	phi = atan(z,x)
	E3DVec3Length@ x,y,z,r
	theta = atan(y,r0)
	theta += degstep
	xmax = r * cos(phi)
	zmax = r * sin(phi)
	y = r * sin(theta)
	x = xmax * cos(theta)
	z = zmax * cos(theta)
	camtargetposx@ = camposx@ + x
	camtargetposz@ = camposz@ + z
	camtargetposy@ = camposy@ + y
	
	E3DSetCameraPos@ camposx@, camposy@, camposz@
	E3DSetCameraTarget@ camtargetposx@,camtargetposy@,camtargetposz@, 0.0, 1.0, 0.0
	return
	
#deffunc cameramovex double camerastep	
	camposx@ += camerastep
	camtargetposx@ += camerastep
	E3DSetCameraPos@ camposx@, camposy@, camposz@
	E3DSetCameraTarget@ camtargetposx@,camtargetposy@,camtargetposz@, 0.0, 1.0, 0.0
	return
	
#deffunc cameramovey double camerastep	
	camposy@ += camerastep
	camtargetposy@ += camerastep
	E3DSetCameraPos@ camposx@, camposy@, camposz@
	E3DSetCameraTarget@ camtargetposx@,camtargetposy@,camtargetposz@, 0.0, 1.0, 0.0
	return

#deffunc cameramovez double camerastep	
	camposz@ += camerastep
	camtargetposz@ += camerastep
	E3DSetCameraPos@ camposx@, camposy@, camposz@
	E3DSetCameraTarget@ camtargetposx@,camtargetposy@,camtargetposz@, 0.0, 1.0, 0.0
	return

#deffunc keycheckdirection
	if keybuf@.VK_UP >= 1{
		playerdirection@ = 4
		if keybuf@.VK_RIGHT >= 1 : playerdirection@ = 5
		if keybuf@.VK_LEFT >= 1 : playerdirection@ = 3
	}
	else{
		if keybuf@.VK_DOWN >= 1{
			playerdirection@ = 0
			if keybuf@.VK_RIGHT >= 1 : playerdirection@ = 7
			if keybuf@.VK_LEFT >= 1 : playerdirection@ = 1
		}
		else{
			if keybuf@.VK_RIGHT >= 1 : playerdirection@ = 6
			if keybuf@.VK_LEFT >= 1 : playerdirection@ = 2
		}
	}
	if playerdirection@ ! -1 : return
	if keybuf@.VK_NUMPAD2 >= 1 : playerdirection@ = 0
	if keybuf@.VK_NUMPAD1 >= 1 : playerdirection@ = 1
	if keybuf@.VK_NUMPAD4 >= 1 : playerdirection@ = 2
	if keybuf@.VK_NUMPAD7 >= 1 : playerdirection@ = 3
	if keybuf@.VK_NUMPAD8 >= 1 : playerdirection@ = 4
	if keybuf@.VK_NUMPAD9 >= 1 : playerdirection@ = 5
	if keybuf@.VK_NUMPAD6 >= 1 : playerdirection@ = 6
	if keybuf@.VK_NUMPAD3 >= 1 : playerdirection@ = 7
	return

#deffunc stageblockcharainit int dfstage
	repeat 30
	dfcnt = cnt
		repeat 30
		blockstate@.cnt.dfcnt = 0
		blocktoobjpart@.cnt.dfcnt = -1
		blockgroup@.cnt.dfcnt = -1
		loop
	loop
	repeat Maxnplayer
	playerkindonstage@.cnt = -1
	loop
	repeat 3
	dfcnt = cnt
		repeat 5
		bullet0state@.dfcnt.cnt = -1
		loop
	loop
	repeat 3
	beam0state@.cnt = -1
	loop
	
	switch dfstage
	case 0
		pathbuf@.0 = mediadir@ + "\\blockx20z1.sig"
		repeat 20
		E3DSigLoad pathbuf@.0, hsidblock@.cnt,0,7.0
		loop

		repeat 20
		dfcnt = cnt 
		setblockparam dfcnt,Bx20z1,5,24 - dfcnt
		loop

		E3DSetPos hsidbodypart@.dfstage,groundx0@ + 700.0 * 22.0 + 350.0,groundy@,groundz0@ + 700.0 * 22.0 + 350.0
		E3DSetDir hsidbodypart@.dfstage,0.0,0.0,0.0

		E3DSetMaterialAlpha hsidplayer@.0,-1,1.0
		E3DSetMotionKind hsidplayer@.0,player_stand
		E3DSetNewPose hsidplayer@.0,framenoplayer@.0
		playerposx@.0 = 0.0 : playerposy@.0 = groundy@ : playerposz@.0 = 0.0
		playerdirx@.0 = 0.0 : playerdiry@.0 = 0.0 : playerdirz@.0 = 0.0
		E3DSetPos hsidplayer@.0,playerposx@.0,playerposy@.0,playerposz@.0
		E3DSetDir hsidplayer@.0,playerdirx@.0,playerdiry@.0,playerdirz@.0
	
		playerkindonstage@.1 = 1
		playerposx@.1 = -5000.0 : playerposy@.1 = groundy@ : playerposz@.1 = -5000.0
		playerdirx@.1 = 0.0 : playerdiry@.1 = 90.0 * rnd(4) : playerdirz@.1 = 0.0
		E3DSetPos hsidplayer@.1,playerposx@.1,playerposy@.1,playerposz@.1
		E3DSetDir hsidplayer@.1,playerdirx@.1,playerdiry@.1,playerdirz@.1
		E3DSetMotionKind hsidplayer@.1,gelsola_walk@
		E3DSetNewPose hsidplayer@.1,framenoplayer@.1
		playermovecnt@.1 = 0

		playerkindonstage@.2 = 1
		playerposx@.2 = -1000.0 : playerposy@.2 = groundy@ : playerposz@.2 = 6000.0
		playerdirx@.2 = 0.0 : playerdiry@.2 = 90.0 * rnd(4) : playerdirz@.2 = 0.0
		E3DSetPos hsidplayer@.2,playerposx@.2,playerposy@.2,playerposz@.2
		E3DSetDir hsidplayer@.2,playerdirx@.2,playerdiry@.2,playerdirz@.2
		E3DSetMotionKind hsidplayer@.2,gelsola_walk@
		E3DSetNewPose hsidplayer@.2,framenoplayer@.2
		playermovecnt@.2 = 50

		playerkindonstage@.3 = 1
		playerposx@.3 = 6000.0 : playerposy@.3 = groundy@ : playerposz@.3 = -7000.0
		playerdirx@.3 = 0.0 : playerdiry@.3 = 90.0 * rnd(4) : playerdirz@.3 = 0.0
		E3DSetPos hsidplayer@.3,playerposx@.3,playerposy@.3,playerposz@.3
		E3DSetDir hsidplayer@.3,playerdirx@.3,playerdiry@.3,playerdirz@.3
		E3DSetMotionKind hsidplayer@.3,gelsola_walk@
		E3DSetNewPose hsidplayer@.3,framenoplayer@.3
		playermovecnt@.3 = 100
	swbreak
	case 1
		pathbuf@.0 = mediadir@ + "\\blockx20z1.sig"
		repeat 5
		E3DSigLoad pathbuf@.0, hsidblock@.cnt,0,7.0
		loop
		pathbuf@.0 = mediadir@ + "\\blockx2z10.sig"
		repeat 4,5
		E3DSigLoad pathbuf@.0, hsidblock@.cnt,0,7.0
		loop
		pathbuf@.0 = mediadir@ + "\\blockx1z20.sig"
		repeat 6,9
		E3DSigLoad pathbuf@.0, hsidblock@.cnt,0,7.0
		loop
		pathbuf@.0 = mediadir@ + "\\blockx20z1.sig"
		repeat 5,15
		E3DSigLoad pathbuf@.0, hsidblock@.cnt,0,7.0
		loop

		repeat 20
		dfcnt = cnt
		if dfcnt < 5 : setblockparam dfcnt,Bx20z1,5,24 - dfcnt
		if (dfcnt = 5)or(dfcnt = 6) : setblockparam dfcnt,Bx2z10,5 + (dfcnt - 5) * 2,10
		if (dfcnt = 7)or(dfcnt = 8) : setblockparam dfcnt,Bx2z10,21 + (dfcnt - 7) * 2,10
		if (dfcnt >= 9)and(dfcnt <= 11) : setblockparam dfcnt,Bx1z20,2 + (dfcnt - 9),5
		if (dfcnt >= 12)and(dfcnt <= 14) : setblockparam dfcnt,Bx1z20,25 + (dfcnt - 12),5
		if dfcnt >= 15 : setblockparam dfcnt,Bx20z1,5,9 - (dfcnt - 15)
		loop
		
		E3DSetPos hsidbodypart@.dfstage,groundx0@ + 700.0 * 22.0 + 350.0,groundy@,groundz0@ + 700.0 * 22.0 + 350.0
		E3DSetDir hsidbodypart@.dfstage,0.0,0.0,0.0

		E3DSetMaterialAlpha hsidplayer@.0,-1,1.0
		E3DSetMotionKind hsidplayer@.0,player_stand
		E3DSetNewPose hsidplayer@.0,framenoplayer@.0
		playerposx@.0 = groundx0@ + 700.0 * 15.0 + 350.0 : playerposy@.0 = groundy@ : playerposz@.0 = groundz0@ + 700.0 * 7.0 + 350.0
		playerdirx@.0 = 0.0 : playerdiry@.0 = 0.0 : playerdirz@.0 = 0.0
		E3DSetPos hsidplayer@.0,playerposx@.0,playerposy@.0,playerposz@.0
		E3DSetDir hsidplayer@.0,playerdirx@.0,playerdiry@.0,playerdirz@.0

		playerkindonstage@.1 = 1
		playerposx@.1 = groundx0@ + 700.0 * 13.0 + 350.0 : playerposy@.1 = groundy@ : playerposz@.1 = groundz0@ + 700.0 * 23.0 + 350.0
		playerdirx@.1 = 0.0 : playerdiry@.1 = 90.0 * rnd(4) : playerdirz@.1 = 0.0
		E3DSetPos hsidplayer@.1,playerposx@.1,playerposy@.1,playerposz@.1
		E3DSetDir hsidplayer@.1,playerdirx@.1,playerdiry@.1,playerdirz@.1
		E3DSetMotionKind hsidplayer@.1,gelsola_walk@
		E3DSetNewPose hsidplayer@.1,framenoplayer@.1
		playermovecnt@.1 = 0

		playerkindonstage@.4 = 2
		playerposx@.4 = groundx0@ + 700.0 * 7.0 + 350.0 : playerposy@.4 = groundy@ : playerposz@.4 = groundz0@ + 700.0 * 17.0 + 350.0
		playerdirx@.4 = 0.0 : playerdiry@.4 = 90.0 * rnd(4) : playerdirz@.4 = 0.0
		E3DSetPos hsidplayer@.4,playerposx@.4,playerposy@.4,playerposz@.4
		E3DSetDir hsidplayer@.4,playerdirx@.4,playerdiry@.4,playerdirz@.4
		E3DSetMotionKind hsidplayer@.4,gelsolb_walk@
		E3DSetNewPose hsidplayer@.4,framenoplayer@.4
		playermovecnt@.4 = 50

		playerkindonstage@.5 = 2
		playerposx@.5 = groundx0@ + 700.0 * 25.0 + 350.0 : playerposy@.5 = groundy@ : playerposz@.5 = groundz0@ + 700.0 * 13.0 + 350.0
		playerdirx@.5 = 0.0 : playerdiry@.5 = 90.0 * rnd(4) : playerdirz@.5 = 0.0
		E3DSetPos hsidplayer@.5,playerposx@.5,playerposy@.5,playerposz@.5
		E3DSetDir hsidplayer@.5,playerdirx@.5,playerdiry@.5,playerdirz@.5
		E3DSetMotionKind hsidplayer@.5,gelsolb_walk@
		E3DSetNewPose hsidplayer@.5,framenoplayer@.5
		playermovecnt@.5 = 100
	swbreak
	case 2
		pathbuf@.0 = mediadir@ + "\\blockx4z5.sig"
		repeat 20
		E3DSigLoad pathbuf@.0, hsidblock@.cnt,0,7.0
		loop

		setblockparam 0,Bx4z5,13,15
		setblockparam 1,Bx4z5,13,10
		repeat 9,2
		dfcnt = cnt
		setblockparam dfcnt,Bx4z5,((dfcnt - 2) \ 3) * 4 + 1,((dfcnt - 2) / 3) * 5 + 14
		loop
		repeat 9,11
		dfcnt = cnt
		setblockparam dfcnt,Bx4z5,((dfcnt - 11) \ 3) * 4 + 17,((dfcnt - 11) / 3) * 5 + 1
		loop

		E3DSetPos hsidbodypart@.dfstage,groundx0@ + 700.0 * 25.0 + 350.0,groundy@,groundz0@ + 700.0 * 12.0 + 350.0
		E3DSetDir hsidbodypart@.dfstage,0.0,0.0,0.0

		E3DSetMaterialAlpha hsidplayer@.0,-1,1.0
		E3DSetMotionKind hsidplayer@.0,player_stand
		E3DSetNewPose hsidplayer@.0,framenoplayer@.0
		playerposx@.0 = groundx0@ + 700.0 * 23.0 + 350.0 : playerposy@.0 = groundy@ : playerposz@.0 = groundz0@ + 700.0 * 7.0 + 350.0
		playerdirx@.0 = 0.0 : playerdiry@.0 = 0.0 : playerdirz@.0 = 0.0
		E3DSetPos hsidplayer@.0,playerposx@.0,playerposy@.0,playerposz@.0
		E3DSetDir hsidplayer@.0,playerdirx@.0,playerdiry@.0,playerdirz@.0

		playerkindonstage@.1 = 1
		playerposx@.1 = groundx0@ + 700.0 * 20.0 + 350.0 : playerposy@.1 = groundy@ : playerposz@.1 = groundz0@ + 700.0 * 12.0 + 350.0
		playerdirx@.1 = 0.0 : playerdiry@.1 = 90.0 * rnd(4) : playerdirz@.1 = 0.0
		E3DSetPos hsidplayer@.1,playerposx@.1,playerposy@.1,playerposz@.1
		E3DSetDir hsidplayer@.1,playerdirx@.1,playerdiry@.1,playerdirz@.1
		E3DSetMotionKind hsidplayer@.1,gelsola_walk@
		E3DSetNewPose hsidplayer@.1,framenoplayer@.1
		playermovecnt@.1 = 0

		playerkindonstage@.2 = 1
		playerposx@.2 = groundx0@ + 700.0 * 3.0 + 350.0 : playerposy@.2 = groundy@ : playerposz@.2 = groundz0@ + 700.0 * 26.0 + 350.0
		playerdirx@.2 = 0.0 : playerdiry@.2 = 90.0 * rnd(4) : playerdirz@.2 = 0.0
		E3DSetPos hsidplayer@.2,playerposx@.2,playerposy@.2,playerposz@.2
		E3DSetDir hsidplayer@.2,playerdirx@.2,playerdiry@.2,playerdirz@.2
		E3DSetMotionKind hsidplayer@.2,gelsola_walk@
		E3DSetNewPose hsidplayer@.2,framenoplayer@.2
		playermovecnt@.2 = 50

		playerkindonstage@.4 = 2
		playerposx@.4 = groundx0@ + 700.0 * 27.0 + 350.0 : playerposy@.4 = groundy@ : playerposz@.4 = groundz0@ + 700.0 * 3.0 + 350.0
		playerdirx@.4 = 0.0 : playerdiry@.4 = 90.0 * rnd(4) : playerdirz@.4 = 0.0
		E3DSetPos hsidplayer@.4,playerposx@.4,playerposy@.4,playerposz@.4
		E3DSetDir hsidplayer@.4,playerdirx@.4,playerdiry@.4,playerdirz@.4
		E3DSetMotionKind hsidplayer@.4,gelsolb_walk@
		E3DSetNewPose hsidplayer@.4,framenoplayer@.4
		playermovecnt@.4 = 100

		playerkindonstage@.5 = 2
		playerposx@.5 = groundx0@ + 700.0 * 10.0 + 350.0 : playerposy@.5 = groundy@ : playerposz@.5 = groundz0@ + 700.0 * 18.0 + 350.0
		playerdirx@.5 = 0.0 : playerdiry@.5 = 90.0 * rnd(4) : playerdirz@.5 = 0.0
		E3DSetPos hsidplayer@.5,playerposx@.5,playerposy@.5,playerposz@.5
		E3DSetDir hsidplayer@.5,playerdirx@.5,playerdiry@.5,playerdirz@.5
		E3DSetMotionKind hsidplayer@.5,gelsolb_walk@
		E3DSetNewPose hsidplayer@.5,framenoplayer@.5
		playermovecnt@.5 = 130
	swbreak
	case 3
		pathbuf@.0 = mediadir@ + "\\blockx10z2.sig"
		repeat 15
		E3DSigLoad pathbuf@.0, hsidblock@.cnt,0,7.0
		loop
		pathbuf@.0 = mediadir@ + "\\blockx4z5.sig"
		repeat 4,15
		E3DSigLoad pathbuf@.0, hsidblock@.cnt,0,7.0
		loop
		pathbuf@.0 = mediadir@ + "\\blockx2z10.sig"
		E3DSigLoad pathbuf@.0, hsidblock@.19,0,7.0
		
		repeat 5
		dfcnt = cnt
		setblockparam dfcnt,Bx10z2,3,27 - 2 * dfcnt
		loop
		repeat 5,5
		dfcnt = cnt
		setblockparam dfcnt,Bx10z2,10,17 - 2 * (dfcnt - 5)
		loop
		repeat 5,10
		dfcnt = cnt
		setblockparam dfcnt,Bx10z2,17,27 - 2 * (dfcnt - 10)
		loop
		setblockparam 15,Bx4z5,4,12
		setblockparam 16,Bx4z5,6,4
		setblockparam 17,Bx4z5,21,4
		setblockparam 18,Bx4z5,22,12
		setblockparam 19,Bx2z10,26,1

		E3DSetPos hsidbodypart@.dfstage,groundx0@ + 700.0 * 27.0 + 350.0,groundy@,groundz0@ + 700.0 * 3.0 + 350.0
		E3DSetDir hsidbodypart@.dfstage,0.0,0.0,0.0

		E3DSetMaterialAlpha hsidplayer@.0,-1,1.0
		E3DSetMotionKind hsidplayer@.0,player_stand
		E3DSetNewPose hsidplayer@.0,framenoplayer@.0
		playerposx@.0 = groundx0@ + 700.0 * 7.0 + 350.0 : playerposy@.0 = groundy@ : playerposz@.0 = groundz0@ + 700.0 * 7.0 + 350.0
		playerdirx@.0 = 0.0 : playerdiry@.0 = 0.0 : playerdirz@.0 = 0.0
		E3DSetPos hsidplayer@.0,playerposx@.0,playerposy@.0,playerposz@.0
		E3DSetDir hsidplayer@.0,playerdirx@.0,playerdiry@.0,playerdirz@.0

		playerkindonstage@.1 = 1
		playerposx@.1 = groundx0@ + 700.0 * 14.0 + 350.0 : playerposy@.1 = groundy@ : playerposz@.1 = groundz0@ + 700.0 * 14.0 + 350.0
		playerdirx@.1 = 0.0 : playerdiry@.1 = 90.0 * rnd(4) : playerdirz@.1 = 0.0
		E3DSetPos hsidplayer@.1,playerposx@.1,playerposy@.1,playerposz@.1
		E3DSetDir hsidplayer@.1,playerdirx@.1,playerdiry@.1,playerdirz@.1
		E3DSetMotionKind hsidplayer@.1,gelsola_walk@
		E3DSetNewPose hsidplayer@.1,framenoplayer@.1
		playermovecnt@.1 = 0

		playerkindonstage@.4 = 2
		playerposx@.4 = groundx0@ + 700.0 * 26.0 + 350.0 : playerposy@.4 = groundy@ : playerposz@.4 = groundz0@ + 700.0 * 8.0 + 350.0
		playerdirx@.4 = 0.0 : playerdiry@.4 = 90.0 * rnd(4) : playerdirz@.4 = 0.0
		E3DSetPos hsidplayer@.4,playerposx@.4,playerposy@.4,playerposz@.4
		E3DSetDir hsidplayer@.4,playerdirx@.4,playerdiry@.4,playerdirz@.4
		E3DSetMotionKind hsidplayer@.4,gelsolb_walk@
		E3DSetNewPose hsidplayer@.4,framenoplayer@.4
		playermovecnt@.4 = 30

		playerkindonstage@.7 = 3
		playerposx@.7 = groundx0@ + 700.0 * 8.0 + 350.0 : playerposy@.7 = groundy@ : playerposz@.7 = groundz0@ + 700.0 * 24.0 + 350.0
		playerdirx@.7 = 0.0 : playerdiry@.7 = 0.0 : playerdirz@.7 = 0.0
		E3DSetPos hsidplayer@.7,playerposx@.7,playerposy@.7,playerposz@.7
		E3DSetDir hsidplayer@.7,playerdirx@.7,playerdiry@.7,playerdirz@.7
		E3DSetMotionKind hsidplayer@.7,hdefencea_stand@
		E3DSetNewPose hsidplayer@.7,framenoplayer@.7
		playermovecnt@.7 = 50

		playerkindonstage@.8 = 3
		playerposx@.8 = groundx0@ + 700.0 * 22.0 + 350.0 : playerposy@.8 = groundy@ : playerposz@.8 = groundz0@ + 700.0 * 25.0 + 350.0
		playerdirx@.8 = 0.0 : playerdiry@.8 = 0.0 : playerdirz@.8 = 0.0
		E3DSetPos hsidplayer@.8,playerposx@.8,playerposy@.8,playerposz@.8
		E3DSetDir hsidplayer@.8,playerdirx@.8,playerdiry@.8,playerdirz@.8
		E3DSetMotionKind hsidplayer@.8,hdefencea_stand@
		E3DSetNewPose hsidplayer@.8,framenoplayer@.8
		playermovecnt@.8 = 80
	swbreak
	case 4
		pathbuf@.0 = mediadir@ + "\\blockx2z10.sig"
		repeat 5
		E3DSigLoad pathbuf@.0, hsidblock@.cnt,0,7.0
		loop
		pathbuf@.0 = mediadir@ + "\\blockx10z2.sig"
		repeat 12,5
		E3DSigLoad pathbuf@.0, hsidblock@.cnt,0,7.0
		loop
		pathbuf@.0 = mediadir@ + "\\blockx4z5.sig"
		E3DSigLoad pathbuf@.0, hsidblock@.17,0,7.0
		E3DSigLoad pathbuf@.0, hsidblock@.18,0,7.0
		pathbuf@.0 = mediadir@ + "\\blockx2z10.sig"
		E3DSigLoad pathbuf@.0, hsidblock@.19,0,7.0

		setblockparam 0,Bx2z10,1,19
		setblockparam 1,Bx2z10,3,18
		setblockparam 2,Bx2z10,5,16
		setblockparam 3,Bx2z10,7,13
		setblockparam 4,Bx2z10,9,10
		repeat 7,5
		dfcnt = cnt
		setblockparam dfcnt,Bx10z2,19 - (dfcnt - 5),23 - 2 * (dfcnt - 5)
		loop
		repeat 5,12
		dfcnt = cnt
		setblockparam dfcnt,Bx10z2,11 - 2 * (dfcnt - 12),9 - 2 * (dfcnt - 12)
		loop
		setblockparam 17,Bx4z5,13,24
		setblockparam 18,Bx4z5,23,6
		setblockparam 19,Bx2z10,27,1

		E3DSetPos hsidbodypart@.dfstage,groundx0@ + 700.0 * 10.0 + 350.0,groundy@,groundz0@ + 700.0 * 11.0 + 350.0
		E3DSetDir hsidbodypart@.dfstage,0.0,0.0,0.0

		E3DSetMaterialAlpha hsidplayer@.0,-1,1.0
		E3DSetMotionKind hsidplayer@.0,player_stand
		E3DSetNewPose hsidplayer@.0,framenoplayer@.0
		playerposx@.0 = groundx0@ + 700.0 * 14.0 + 350.0 : playerposy@.0 = groundy@ : playerposz@.0 = groundz0@ + 700.0 * 26.0 + 350.0
		playerdirx@.0 = 0.0 : playerdiry@.0 = 0.0 : playerdirz@.0 = 0.0
		E3DSetPos hsidplayer@.0,playerposx@.0,playerposy@.0,playerposz@.0
		E3DSetDir hsidplayer@.0,playerdirx@.0,playerdiry@.0,playerdirz@.0

		playerkindonstage@.4 = 2
		playerposx@.4 = groundx0@ + 700.0 * 11.0 + 350.0 : playerposy@.4 = groundy@ : playerposz@.4 = groundz0@ + 700.0 * 10.0 + 350.0
		playerdirx@.4 = 0.0 : playerdiry@.4 = 90.0 * rnd(4) : playerdirz@.4 = 0.0
		E3DSetPos hsidplayer@.4,playerposx@.4,playerposy@.4,playerposz@.4
		E3DSetDir hsidplayer@.4,playerdirx@.4,playerdiry@.4,playerdirz@.4
		E3DSetMotionKind hsidplayer@.4,gelsolb_walk@
		E3DSetNewPose hsidplayer@.4,framenoplayer@.4
		playermovecnt@.4 = 30

		playerkindonstage@.7 = 3
		playerposx@.7 = groundx0@ + 700.0 * 21.0 + 350.0 : playerposy@.7 = groundy@ : playerposz@.7 = groundz0@ + 700.0 * 21.0 + 350.0
		playerdirx@.7 = 0.0 : playerdiry@.7 = 0.0 : playerdirz@.7 = 0.0
		E3DSetPos hsidplayer@.7,playerposx@.7,playerposy@.7,playerposz@.7
		E3DSetDir hsidplayer@.7,playerdirx@.7,playerdiry@.7,playerdirz@.7
		E3DSetMotionKind hsidplayer@.7,hdefencea_stand@
		E3DSetNewPose hsidplayer@.7,framenoplayer@.7
		playermovecnt@.7 = 0

		playerkindonstage@.8 = 3
		playerposx@.8 = groundx0@ + 700.0 * 5.0 + 350.0 : playerposy@.8 = groundy@ : playerposz@.8 = groundz0@ + 700.0 * 20.0 + 350.0
		playerdirx@.8 = 0.0 : playerdiry@.8 = 0.0 : playerdirz@.8 = 0.0
		E3DSetPos hsidplayer@.8,playerposx@.8,playerposy@.8,playerposz@.8
		E3DSetDir hsidplayer@.8,playerdirx@.8,playerdiry@.8,playerdirz@.8
		E3DSetMotionKind hsidplayer@.8,hdefencea_stand@
		E3DSetNewPose hsidplayer@.8,framenoplayer@.8
		playermovecnt@.8 = 30
		
		playerkindonstage@.9 = 3
		playerposx@.9 = groundx0@ + 700.0 * 25.0 + 350.0 : playerposy@.9 = groundy@ : playerposz@.9 = groundz0@ + 700.0 * 8.0 + 350.0
		playerdirx@.9 = 0.0 : playerdiry@.9 = 0.0 : playerdirz@.9 = 0.0
		E3DSetPos hsidplayer@.9,playerposx@.9,playerposy@.9,playerposz@.9
		E3DSetDir hsidplayer@.9,playerdirx@.9,playerdiry@.9,playerdirz@.9
		E3DSetMotionKind hsidplayer@.9,hdefencea_stand@
		E3DSetNewPose hsidplayer@.9,framenoplayer@.9
		playermovecnt@.9 = 60
	swbreak
	case 5
		pathbuf@.0 = mediadir@ + "\\blockx10z2.sig"
		repeat 5
		E3DSigLoad pathbuf@.0, hsidblock@.cnt,0,7.0
		loop
		pathbuf@.0 = mediadir@ + "\\blockx2z10.sig"
		E3DSigLoad pathbuf@.0, hsidblock@.5,0,7.0
		E3DSigLoad pathbuf@.0, hsidblock@.6,0,7.0
		pathbuf@.0 = mediadir@ + "\\blockx4z5.sig"
		E3DSigLoad pathbuf@.0, hsidblock@.7,0,7.0
		E3DSigLoad pathbuf@.0, hsidblock@.8,0,7.0
		pathbuf@.0 = mediadir@ + "\\blockx20z1.sig"
		repeat 2,9
		E3DSigLoad pathbuf@.0, hsidblock@.cnt,0,7.0
		loop
		pathbuf@.0 = mediadir@ + "\\blockx10z2.sig"
		repeat 5,11
		E3DSigLoad pathbuf@.0, hsidblock@.cnt,0,7.0
		loop
		pathbuf@.0 = mediadir@ + "\\blocklx23456z5.sig"
		E3DSigLoad pathbuf@.0, hsidblock@.16,0,7.0
		pathbuf@.0 = mediadir@ + "\\blocklx65432z5.sig"
		E3DSigLoad pathbuf@.0, hsidblock@.17,0,7.0
		pathbuf@.0 = mediadir@ + "\\blockrx23456z5.sig"
		E3DSigLoad pathbuf@.0, hsidblock@.18,0,7.0
		pathbuf@.0 = mediadir@ + "\\blockrx65432z5.sig"
		E3DSigLoad pathbuf@.0, hsidblock@.19,0,7.0

		repeat 5
		dfcnt = cnt
		setblockparam dfcnt,Bx10z2,10,27 - 2 * dfcnt
		loop
		setblockparam 5,Bx2z10,8,19
		setblockparam 6,Bx2z10,20,19
		setblockparam 7,Bx4z5,4,22
		setblockparam 8,Bx4z5,22,22
		setblockparam 9,Bx20z1,5,15
		setblockparam 10,Bx20z1,5,16
		repeat 5,11
		dfcnt = cnt
		setblockparam dfcnt,Bx10z2,10,9 - 2 * (dfcnt - 11)
		loop
		setblockparam 16,Blx23456z5,4,6
		setblockparam 17,Blx65432z5,4,1
		setblockparam 18,Brx23456z5,20,6
		setblockparam 19,Brx65432z5,20,1

		E3DSetPos hsidbodypart@.dfstage,groundx0@ + 700.0 * 22.0 + 350.0,groundy@,groundz0@ + 700.0 * 24.0 + 350.0
		E3DSetDir hsidbodypart@.dfstage,0.0,0.0,0.0

		E3DSetMaterialAlpha hsidplayer@.0,-1,1.0
		E3DSetMotionKind hsidplayer@.0,player_stand
		E3DSetNewPose hsidplayer@.0,framenoplayer@.0
		playerposx@.0 = groundx0@ + 700.0 * 24.0 + 350.0 : playerposy@.0 = groundy@ : playerposz@.0 = groundz0@ + 700.0 * 6.0 + 350.0
		playerdirx@.0 = 0.0 : playerdiry@.0 = 0.0 : playerdirz@.0 = 0.0
		E3DSetPos hsidplayer@.0,playerposx@.0,playerposy@.0,playerposz@.0
		E3DSetDir hsidplayer@.0,playerdirx@.0,playerdiry@.0,playerdirz@.0

		playerkindonstage@.1 = 1
		playerposx@.1 = groundx0@ + 700.0 * 10.0 + 350.0 : playerposy@.1 = groundy@ : playerposz@.1 = groundz0@ + 700.0 * 20.0 + 350.0
		playerdirx@.1 = 0.0 : playerdiry@.1 = 90.0 * rnd(4) : playerdirz@.1 = 0.0
		E3DSetPos hsidplayer@.1,playerposx@.1,playerposy@.1,playerposz@.1
		E3DSetDir hsidplayer@.1,playerdirx@.1,playerdiry@.1,playerdirz@.1
		E3DSetMotionKind hsidplayer@.1,gelsola_walk@
		E3DSetNewPose hsidplayer@.1,framenoplayer@.1
		playermovecnt@.1 = 0

		playerkindonstage@.4 = 2
		playerposx@.4 = groundx0@ + 700.0 * 8.0 + 350.0 : playerposy@.4 = groundy@ : playerposz@.4 = groundz0@ + 700.0 * 15.0 + 350.0
		playerdirx@.4 = 0.0 : playerdiry@.4 = 90.0 * rnd(4) : playerdirz@.4 = 0.0
		E3DSetPos hsidplayer@.4,playerposx@.4,playerposy@.4,playerposz@.4
		E3DSetDir hsidplayer@.4,playerdirx@.4,playerdiry@.4,playerdirz@.4
		E3DSetMotionKind hsidplayer@.4,gelsolb_walk@
		E3DSetNewPose hsidplayer@.4,framenoplayer@.4
		playermovecnt@.4 = 30
		
		playerkindonstage@.7 = 3
		playerposx@.7 = groundx0@ + 700.0 * 10.0 + 350.0 : playerposy@.7 = groundy@ : playerposz@.7 = groundz0@ + 700.0 * 3.0 + 350.0
		playerdirx@.7 = 0.0 : playerdiry@.7 = 0.0 : playerdirz@.7 = 0.0
		E3DSetPos hsidplayer@.7,playerposx@.7,playerposy@.7,playerposz@.7
		E3DSetDir hsidplayer@.7,playerdirx@.7,playerdiry@.7,playerdirz@.7
		E3DSetMotionKind hsidplayer@.7,hdefencea_stand@
		E3DSetNewPose hsidplayer@.7,framenoplayer@.7
		playermovecnt@.7 = 50

		playerkindonstage@.10 = 4
		playerposx@.10 = groundx0@ + 700.0 * 18.0 + 350.0 : playerposy@.10 = groundy@ : playerposz@.10 = groundz0@ + 700.0 * 8.0 + 350.0
		playerdirx@.10 = 0.0 : playerdiry@.10 = 0.0 : playerdirz@.10 = 0.0
		E3DSetPos hsidplayer@.10,playerposx@.10,playerposy@.10,playerposz@.10
		E3DSetDir hsidplayer@.10,playerdirx@.10,playerdiry@.10,playerdirz@.10
		E3DSetMotionKind hsidplayer@.10,hdefenceb_normal@
		E3DSetNewPose hsidplayer@.10,framenoplayer@.10
		playermovecnt@.10 = 0
	swbreak
	case 6
		pathbuf@.0 = mediadir@ + "\\blockx4z5.sig"
		repeat 9
		E3DSigLoad pathbuf@.0, hsidblock@.cnt,0,7.0
		loop
		pathbuf@.0 = mediadir@ + "\\blockx2z10.sig"
		E3DSigLoad pathbuf@.0, hsidblock@.9,0,7.0
		E3DSigLoad pathbuf@.0, hsidblock@.10,0,7.0
		pathbuf@.0 = mediadir@ + "\\blockx20z1.sig"
		E3DSigLoad pathbuf@.0, hsidblock@.11,0,7.0
		E3DSigLoad pathbuf@.0, hsidblock@.12,0,7.0
		pathbuf@.0 = mediadir@ + "\\blockx4z5.sig"
		repeat 3,13
		E3DSigLoad pathbuf@.0, hsidblock@.cnt,0,7.0
		loop
		pathbuf@.0 = mediadir@ + "\\blockx2z10.sig"
		E3DSigLoad pathbuf@.0, hsidblock@.16,0,7.0
		E3DSigLoad pathbuf@.0, hsidblock@.17,0,7.0
		pathbuf@.0 = mediadir@ + "\\blockx10z2.sig"
		repeat 2,18
		E3DSigLoad pathbuf@.0, hsidblock@.cnt,0,7.0
		loop

		repeat 9
		dfcnt = cnt
		setblockparam dfcnt,Bx4z5,9 + 4 * (dfcnt \ 3),24 - 5 * (dfcnt / 3)
		loop
		setblockparam 9,Bx2z10,7,14
		setblockparam 10,Bx2z10,21,13
		setblockparam 11,Bx20z1,1,13
		setblockparam 12,Bx20z1,9,12
		repeat 3,13
		dfcnt = cnt
		setblockparam dfcnt,Bx4z5,9 + 4 * (dfcnt - 13),7
		loop
		setblockparam 16,Bx2z10,7,3
		setblockparam 17,Bx2z10,21,2
		setblockparam 18,Bx10z2,9,5
		setblockparam 19,Bx10z2,9,3

		E3DSetPos hsidbodypart@.dfstage,groundx0@ + 700.0 * 28.0 + 350.0,groundy@,groundz0@ + 700.0 * 12.0 + 350.0
		E3DSetDir hsidbodypart@.dfstage,0.0,0.0,0.0

		E3DSetMaterialAlpha hsidplayer@.0,-1,1.0
		E3DSetMotionKind hsidplayer@.0,player_stand
		E3DSetNewPose hsidplayer@.0,framenoplayer@.0
		playerposx@.0 = groundx0@ + 700.0 * 21.0 + 350.0 : playerposy@.0 = groundy@ : playerposz@.0 = groundz0@ + 700.0 * 3.0 + 350.0
		playerdirx@.0 = 0.0 : playerdiry@.0 = 0.0 : playerdirz@.0 = 0.0
		E3DSetPos hsidplayer@.0,playerposx@.0,playerposy@.0,playerposz@.0
		E3DSetDir hsidplayer@.0,playerdirx@.0,playerdiry@.0,playerdirz@.0

		playerkindonstage@.4 = 2
		playerposx@.4 = groundx0@ + 700.0 * 11.0 + 350.0 : playerposy@.4 = groundy@ : playerposz@.4 = groundz0@ + 700.0 * 24.0 + 350.0
		playerdirx@.4 = 0.0 : playerdiry@.4 = 90.0 * rnd(4) : playerdirz@.4 = 0.0
		E3DSetPos hsidplayer@.4,playerposx@.4,playerposy@.4,playerposz@.4
		E3DSetDir hsidplayer@.4,playerdirx@.4,playerdiry@.4,playerdirz@.4
		E3DSetMotionKind hsidplayer@.4,gelsolb_walk@
		E3DSetNewPose hsidplayer@.4,framenoplayer@.4
		playermovecnt@.4 = 0

		playerkindonstage@.7 = 3
		playerposx@.7 = groundx0@ + 700.0 * 19.0 + 350.0 : playerposy@.7 = groundy@ : playerposz@.7 = groundz0@ + 700.0 * 12.0 + 350.0
		playerdirx@.7 = 0.0 : playerdiry@.7 = 0.0 : playerdirz@.7 = 0.0
		E3DSetPos hsidplayer@.7,playerposx@.7,playerposy@.7,playerposz@.7
		E3DSetDir hsidplayer@.7,playerdirx@.7,playerdiry@.7,playerdirz@.7
		E3DSetMotionKind hsidplayer@.7,hdefencea_stand@
		E3DSetNewPose hsidplayer@.7,framenoplayer@.7
		playermovecnt@.7 = 20

		playerkindonstage@.10 = 4
		playerposx@.10 = groundx0@ + 700.0 * 18.0 + 350.0 : playerposy@.10 = groundy@ : playerposz@.10 = groundz0@ + 700.0 * 21.0 + 350.0
		playerdirx@.10 = 0.0 : playerdiry@.10 = 0.0 : playerdirz@.10 = 0.0
		E3DSetPos hsidplayer@.10,playerposx@.10,playerposy@.10,playerposz@.10
		E3DSetDir hsidplayer@.10,playerdirx@.10,playerdiry@.10,playerdirz@.10
		E3DSetMotionKind hsidplayer@.10,hdefenceb_normal@
		E3DSetNewPose hsidplayer@.10,framenoplayer@.10
		playermovecnt@.10 = 0

		playerkindonstage@.11 = 4
		playerposx@.11 = groundx0@ + 700.0 * 10.0 + 350.0 : playerposy@.11 = groundy@ : playerposz@.11 = groundz0@ + 700.0 * 10.0 + 350.0
		playerdirx@.11 = 0.0 : playerdiry@.11 = 0.0 : playerdirz@.11 = 0.0
		E3DSetPos hsidplayer@.11,playerposx@.11,playerposy@.11,playerposz@.11
		E3DSetDir hsidplayer@.11,playerdirx@.11,playerdiry@.11,playerdirz@.11
		E3DSetMotionKind hsidplayer@.11,hdefenceb_normal@
		E3DSetNewPose hsidplayer@.11,framenoplayer@.11
		playermovecnt@.11 = 40
	swbreak
	case 7
		pathbuf@.0 = mediadir@ + "\\blockx2z10.sig"
		repeat 4
		E3DSigLoad pathbuf@.0, hsidblock@.cnt,0,7.0
		loop
		pathbuf@.0 = mediadir@ + "\\blocklx23456z5.sig"
		E3DSigLoad pathbuf@.0, hsidblock@.4,0,7.0
		pathbuf@.0 = mediadir@ + "\\blockrx65432z5.sig"
		E3DSigLoad pathbuf@.0, hsidblock@.5,0,7.0
		pathbuf@.0 = mediadir@ + "\\blockx4z5.sig"
		E3DSigLoad pathbuf@.0, hsidblock@.6,0,7.0
		pathbuf@.0 = mediadir@ + "\\blockrx23456z5.sig"
		E3DSigLoad pathbuf@.0, hsidblock@.7,0,7.0
		pathbuf@.0 = mediadir@ + "\\blocklx65432z5.sig"
		E3DSigLoad pathbuf@.0, hsidblock@.8,0,7.0
		pathbuf@.0 = mediadir@ + "\\blockx4z5.sig"
		repeat 6,9
		E3DSigLoad pathbuf@.0, hsidblock@.cnt,0,7.0
		loop
		pathbuf@.0 = mediadir@ + "\\blockrx23456z5.sig"
		E3DSigLoad pathbuf@.0, hsidblock@.15,0,7.0
		pathbuf@.0 = mediadir@ + "\\blocklx65432z5.sig"
		E3DSigLoad pathbuf@.0, hsidblock@.16,0,7.0
		pathbuf@.0 = mediadir@ + "\\blockx4z5.sig"
		E3DSigLoad pathbuf@.0, hsidblock@.17,0,7.0
		pathbuf@.0 = mediadir@ + "\\blocklx23456z5.sig"
		E3DSigLoad pathbuf@.0, hsidblock@.18,0,7.0
		pathbuf@.0 = mediadir@ + "\\blockrx65432z5.sig"
		E3DSigLoad pathbuf@.0, hsidblock@.19,0,7.0

		setblockparam 0,Bx2z10,1,13
		setblockparam 1,Bx2z10,1,3
		setblockparam 2,Bx2z10,27,13
		setblockparam 3,Bx2z10,27,3
		setblockparam 4,Blx23456z5,3,23
		setblockparam 5,Brx65432z5,3,18
		setblockparam 6,Bx4z5,3,13
		setblockparam 7,Brx23456z5,3,8
		setblockparam 8,Blx65432z5,3,3
		setblockparam 9,Bx4z5,9,22
		setblockparam 10,Bx4z5,13,22
		setblockparam 11,Bx4z5,17,22
		setblockparam 12,Bx4z5,9,3
		setblockparam 13,Bx4z5,13,3
		setblockparam 14,Bx4z5,17,3
		setblockparam 15,Brx23456z5,21,23
		setblockparam 16,Blx65432z5,21,18
		setblockparam 17,Bx4z5,23,13
		setblockparam 18,Blx23456z5,21,8
		setblockparam 19,Brx65432z5,21,3
		
		E3DSetPos hsidbodypart@.dfstage,groundx0@ + 700.0 * 26.0 + 350.0,groundy@,groundz0@ + 700.0 * 10.0 + 350.0
		E3DSetDir hsidbodypart@.dfstage,0.0,0.0,0.0

		E3DSetMaterialAlpha hsidplayer@.0,-1,1.0
		E3DSetMotionKind hsidplayer@.0,player_stand
		E3DSetNewPose hsidplayer@.0,framenoplayer@.0
		playerposx@.0 = groundx0@ + 700.0 * 4.0 + 350.0 : playerposy@.0 = groundy@ : playerposz@.0 = groundz0@ + 700.0 * 8.0 + 350.0
		playerdirx@.0 = 0.0 : playerdiry@.0 = 0.0 : playerdirz@.0 = 0.0
		E3DSetPos hsidplayer@.0,playerposx@.0,playerposy@.0,playerposz@.0
		E3DSetDir hsidplayer@.0,playerdirx@.0,playerdiry@.0,playerdirz@.0

		playerkindonstage@.1 = 1
		playerposx@.1 = groundx0@ + 700.0 * 8.0 + 350.0 : playerposy@.1 = groundy@ : playerposz@.1 = groundz0@ + 700.0 * 6.0 + 350.0
		playerdirx@.1 = 0.0 : playerdiry@.1 = 90.0 * rnd(4) : playerdirz@.1 = 0.0
		E3DSetPos hsidplayer@.1,playerposx@.1,playerposy@.1,playerposz@.1
		E3DSetDir hsidplayer@.1,playerdirx@.1,playerdiry@.1,playerdirz@.1
		E3DSetMotionKind hsidplayer@.1,gelsola_walk@
		E3DSetNewPose hsidplayer@.1,framenoplayer@.1
		playermovecnt@.1 = 0

		playerkindonstage@.7 = 3
		playerposx@.7 = groundx0@ + 700.0 * 19.0 + 350.0 : playerposy@.7 = groundy@ : playerposz@.7 = groundz0@ + 700.0 * 5.0 + 350.0
		playerdirx@.7 = 0.0 : playerdiry@.7 = 0.0 : playerdirz@.7 = 0.0
		E3DSetPos hsidplayer@.7,playerposx@.7,playerposy@.7,playerposz@.7
		E3DSetDir hsidplayer@.7,playerdirx@.7,playerdiry@.7,playerdirz@.7
		E3DSetMotionKind hsidplayer@.7,hdefencea_stand@
		E3DSetNewPose hsidplayer@.7,framenoplayer@.7
		playermovecnt@.7 = 20

		playerkindonstage@.10 = 4
		playerposx@.10 = groundx0@ + 700.0 * 22.0 + 350.0 : playerposy@.10 = groundy@ : playerposz@.10 = groundz0@ + 700.0 * 24.0 + 350.0
		playerdirx@.10 = 0.0 : playerdiry@.10 = 0.0 : playerdirz@.10 = 0.0
		E3DSetPos hsidplayer@.10,playerposx@.10,playerposy@.10,playerposz@.10
		E3DSetDir hsidplayer@.10,playerdirx@.10,playerdiry@.10,playerdirz@.10
		E3DSetMotionKind hsidplayer@.10,hdefenceb_normal@
		E3DSetNewPose hsidplayer@.10,framenoplayer@.10
		playermovecnt@.10 = 40

		playerkindonstage@.13 = 5
		playerposx@.13 = groundx0@ + 700.0 * 15.0 + 350.0 : playerposy@.13 = groundy@ : playerposz@.13 = groundz0@ + 700.0 * 24.0 + 350.0
		playerdirx@.13 = 0.0 : playerdiry@.13 = 0.0 : playerdirz@.13 = 0.0
		E3DSetPos hsidplayer@.13,playerposx@.13,playerposy@.13,playerposz@.13
		E3DSetDir hsidplayer@.13,playerdirx@.13,playerdiry@.13,playerdirz@.13
		E3DSetMotionKind hsidplayer@.13,fluida_stand@
		E3DSetNewPose hsidplayer@.13,framenoplayer@.13
		playermovecnt@.13 = 0
		repeat 30
		dfcnt = cnt
			repeat 30
			pathmatrix@.0.cnt.dfcnt = blockgroup@.cnt.dfcnt
			loop
		loop
		pathmatrixset dfstage,0,0
		E3DInitParticle ptlid1@
	swbreak
	case 8
		pathbuf@.0 = mediadir@ + "\\blockx10z2.sig"
		repeat 2
		E3DSigLoad pathbuf@.0, hsidblock@.cnt,0,7.0
		loop
		pathbuf@.0 = mediadir@ + "\\blockx4z5.sig"
		repeat 12,2
		E3DSigLoad pathbuf@.0, hsidblock@.cnt,0,7.0
		loop
		pathbuf@.0 = mediadir@ + "\\blockx20z1.sig"
		repeat 6,14
		E3DSigLoad pathbuf@.0, hsidblock@.cnt,0,7.0
		loop
		
		setblockparam 0,Bx10z2,2,26
		setblockparam 1,Bx10z2,16,26
		setblockparam 2,Bx4z5,12,24
		setblockparam 3,Bx4z5,25,23
		setblockparam 4,Bx4z5,25,18
		setblockparam 5,Bx4z5,1,15
		setblockparam 6,Bx4z5,1,10
		setblockparam 7,Bx4z5,25,7
		setblockparam 8,Bx4z5,25,2
		setblockparam 9,Bx4z5,19,2
		setblockparam 10,Bx4z5,13,2
		setblockparam 11,Bx4z5,9,2
		setblockparam 12,Bx4z5,5,2
		setblockparam 13,Bx4z5,1,2
		setblockparam 14,Bx20z1,5,19
		setblockparam 15,Bx20z1,5,18
		setblockparam 16,Bx20z1,5,17
		setblockparam 17,Bx20z1,5,11
		setblockparam 18,Bx20z1,5,10
		setblockparam 19,Bx20z1,5,9

		E3DSetPos hsidbodypart@.dfstage,groundx0@ + 700.0 * 14.0 + 350.0,groundy@,groundz0@ + 700.0 * 26.0 + 350.0
		E3DSetDir hsidbodypart@.dfstage,0.0,0.0,0.0

		E3DSetMaterialAlpha hsidplayer@.0,-1,1.0
		E3DSetMotionKind hsidplayer@.0,player_stand
		E3DSetNewPose hsidplayer@.0,framenoplayer@.0
		playerposx@.0 = groundx0@ + 700.0 * 9.0 + 350.0 : playerposy@.0 = groundy@ : playerposz@.0 = groundz0@ + 700.0 * 4.0 + 350.0
		playerdirx@.0 = 0.0 : playerdiry@.0 = 0.0 : playerdirz@.0 = 0.0
		E3DSetPos hsidplayer@.0,playerposx@.0,playerposy@.0,playerposz@.0
		E3DSetDir hsidplayer@.0,playerdirx@.0,playerdiry@.0,playerdirz@.0

		playerkindonstage@.4 = 2
		playerposx@.4 = groundx0@ + 700.0 * 6.0 + 350.0 : playerposy@.4 = groundy@ : playerposz@.4 = groundz0@ + 700.0 * 5.0 + 350.0
		playerdirx@.4 = 0.0 : playerdiry@.4 = 90.0 * rnd(4) : playerdirz@.4 = 0.0
		E3DSetPos hsidplayer@.4,playerposx@.4,playerposy@.4,playerposz@.4
		E3DSetDir hsidplayer@.4,playerdirx@.4,playerdiry@.4,playerdirz@.4
		E3DSetMotionKind hsidplayer@.4,gelsolb_walk@
		E3DSetNewPose hsidplayer@.4,framenoplayer@.4
		playermovecnt@.4 = 0

		playerkindonstage@.7 = 3
		playerposx@.7 = groundx0@ + 700.0 * 13.0 + 350.0 : playerposy@.7 = groundy@ : playerposz@.7 = groundz0@ + 700.0 * 2.0 + 350.0
		playerdirx@.7 = 0.0 : playerdiry@.7 = 0.0 : playerdirz@.7 = 0.0
		E3DSetPos hsidplayer@.7,playerposx@.7,playerposy@.7,playerposz@.7
		E3DSetDir hsidplayer@.7,playerdirx@.7,playerdiry@.7,playerdirz@.7
		E3DSetMotionKind hsidplayer@.7,hdefencea_stand@
		E3DSetNewPose hsidplayer@.7,framenoplayer@.7
		playermovecnt@.7 = 50

		playerkindonstage@.10 = 4
		playerposx@.10 = groundx0@ + 700.0 * 15.0 + 350.0 : playerposy@.10 = groundy@ : playerposz@.10 = groundz0@ + 700.0 * 5.0 + 350.0
		playerdirx@.10 = 0.0 : playerdiry@.10 = 0.0 : playerdirz@.10 = 0.0
		E3DSetPos hsidplayer@.10,playerposx@.10,playerposy@.10,playerposz@.10
		E3DSetDir hsidplayer@.10,playerdirx@.10,playerdiry@.10,playerdirz@.10
		E3DSetMotionKind hsidplayer@.10,hdefenceb_normal@
		E3DSetNewPose hsidplayer@.10,framenoplayer@.10
		playermovecnt@.10 = 0

		playerkindonstage@.13 = 5
		playerposx@.13 = groundx0@ + 700.0 * 3.0 + 350.0 : playerposy@.13 = groundy@ : playerposz@.13 = groundz0@ + 700.0 * 26.0 + 350.0
		playerdirx@.13 = 0.0 : playerdiry@.13 = 0.0 : playerdirz@.13 = 0.0
		E3DSetPos hsidplayer@.13,playerposx@.13,playerposy@.13,playerposz@.13
		E3DSetDir hsidplayer@.13,playerdirx@.13,playerdiry@.13,playerdirz@.13
		E3DSetMotionKind hsidplayer@.13,fluida_stand@
		E3DSetNewPose hsidplayer@.13,framenoplayer@.13
		playermovecnt@.13 = 0
		repeat 30
		dfcnt = cnt
			repeat 30
			pathmatrix@.0.cnt.dfcnt = blockgroup@.cnt.dfcnt
			loop
		loop
		pathmatrixset dfstage,0,0
		E3DInitParticle ptlid1@

		playerkindonstage@.14 = 5
		playerposx@.14 = groundx0@ + 700.0 * 27.0 + 350.0 : playerposy@.14 = groundy@ : playerposz@.14 = groundz0@ + 700.0 * 21.0 + 350.0
		playerdirx@.14 = 0.0 : playerdiry@.14 = 0.0 : playerdirz@.14 = 0.0
		E3DSetPos hsidplayer@.14,playerposx@.14,playerposy@.14,playerposz@.14
		E3DSetDir hsidplayer@.14,playerdirx@.14,playerdiry@.14,playerdirz@.14
		E3DSetMotionKind hsidplayer@.14,fluida_stand@
		E3DSetNewPose hsidplayer@.14,framenoplayer@.14
		playermovecnt@.14 = 0
		repeat 30
		dfcnt = cnt
			repeat 30
			pathmatrix@.1.cnt.dfcnt = blockgroup@.cnt.dfcnt
			loop
		loop
		pathmatrixset dfstage,1,0
		E3DInitParticle ptlid2@
	swbreak
	case 9
		pathbuf@.0 = mediadir@ + "\\blockx2z10.sig"
		E3DSigLoad pathbuf@.0, hsidblock@.0,0,7.0
		pathbuf@.0 = mediadir@ + "\\blockx4z5.sig"
		repeat 7,1
		E3DSigLoad pathbuf@.0, hsidblock@.cnt,0,7.0
		loop
		pathbuf@.0 = mediadir@ + "\\blockx10z2.sig"
		repeat 10,8
		E3DSigLoad pathbuf@.0, hsidblock@.cnt,0,7.0
		loop
		pathbuf@.0 = mediadir@ + "\\blockx20z1.sig"
		E3DSigLoad pathbuf@.0, hsidblock@.18,0,7.0
		E3DSigLoad pathbuf@.0, hsidblock@.19,0,7.0
		
		setblockparam 0,Bx2z10,23,19
		setblockparam 1,Bx4z5,1,24
		setblockparam 2,Bx4z5,8,16
		setblockparam 3,Bx4z5,19,19
		setblockparam 4,Bx4z5,25,19
		setblockparam 5,Bx4z5,15,10
		setblockparam 6,Bx4z5,11,5
		setblockparam 7,Bx4z5,15,5
		setblockparam 8,Bx10z2,19,17
		setblockparam 9,Bx10z2,19,15
		setblockparam 10,Bx10z2,19,13
		setblockparam 11,Bx10z2,19,11
		setblockparam 12,Bx10z2,19,9
		setblockparam 13,Bx10z2,19,7
		setblockparam 14,Bx10z2,19,5
		setblockparam 15,Bx10z2,1,5
		setblockparam 16,Bx10z2,5,3
		setblockparam 17,Bx10z2,15,3
		setblockparam 18,Bx20z1,5,2
		setblockparam 19,Bx20z1,5,1

		E3DSetPos hsidbodypart@.dfstage,groundx0@ + 700.0 * 23.0 + 350.0,groundy@,groundz0@ + 700.0 * 28.0 + 350.0
		E3DSetDir hsidbodypart@.dfstage,0.0,0.0,0.0

		E3DSetMaterialAlpha hsidplayer@.0,-1,1.0
		E3DSetMotionKind hsidplayer@.0,player_stand
		E3DSetNewPose hsidplayer@.0,framenoplayer@.0
		playerposx@.0 = groundx0@ + 700.0 * 9.0 + 350.0 : playerposy@.0 = groundy@ : playerposz@.0 = groundz0@ + 700.0 * 17.0 + 350.0
		playerdirx@.0 = 0.0 : playerdiry@.0 = 0.0 : playerdirz@.0 = 0.0
		E3DSetPos hsidplayer@.0,playerposx@.0,playerposy@.0,playerposz@.0
		E3DSetDir hsidplayer@.0,playerdirx@.0,playerdiry@.0,playerdirz@.0

		playerkindonstage@.4 = 2
		playerposx@.4 = groundx0@ + 700.0 * 11.0 + 350.0 : playerposy@.4 = groundy@ : playerposz@.4 = groundz0@ + 700.0 * 3.0 + 350.0
		playerdirx@.4 = 0.0 : playerdiry@.4 = 90.0 * rnd(4) : playerdirz@.4 = 0.0
		E3DSetPos hsidplayer@.4,playerposx@.4,playerposy@.4,playerposz@.4
		E3DSetDir hsidplayer@.4,playerdirx@.4,playerdiry@.4,playerdirz@.4
		E3DSetMotionKind hsidplayer@.4,gelsolb_walk@
		E3DSetNewPose hsidplayer@.4,framenoplayer@.4
		playermovecnt@.4 = 0

		playerkindonstage@.7 = 3
		playerposx@.7 = groundx0@ + 700.0 * 19.0 + 350.0 : playerposy@.7 = groundy@ : playerposz@.7 = groundz0@ + 700.0 * 12.0 + 350.0
		playerdirx@.7 = 0.0 : playerdiry@.7 = 0.0 : playerdirz@.7 = 0.0
		E3DSetPos hsidplayer@.7,playerposx@.7,playerposy@.7,playerposz@.7
		E3DSetDir hsidplayer@.7,playerdirx@.7,playerdiry@.7,playerdirz@.7
		E3DSetMotionKind hsidplayer@.7,hdefencea_stand@
		E3DSetNewPose hsidplayer@.7,framenoplayer@.7
		playermovecnt@.7 = 50

		playerkindonstage@.10 = 4
		playerposx@.10 = groundx0@ + 700.0 * 25.0 + 350.0 : playerposy@.10 = groundy@ : playerposz@.10 = groundz0@ + 700.0 * 8.0 + 350.0
		playerdirx@.10 = 0.0 : playerdiry@.10 = 0.0 : playerdirz@.10 = 0.0
		E3DSetPos hsidplayer@.10,playerposx@.10,playerposy@.10,playerposz@.10
		E3DSetDir hsidplayer@.10,playerdirx@.10,playerdiry@.10,playerdirz@.10
		E3DSetMotionKind hsidplayer@.10,hdefenceb_normal@
		E3DSetNewPose hsidplayer@.10,framenoplayer@.10
		playermovecnt@.10 = 0

		playerkindonstage@.13 = 5
		playerposx@.13 = groundx0@ + 700.0 * 16.0 + 350.0 : playerposy@.13 = groundy@ : playerposz@.13 = groundz0@ + 700.0 * 13.0 + 350.0
		playerdirx@.13 = 0.0 : playerdiry@.13 = 0.0 : playerdirz@.13 = 0.0
		E3DSetPos hsidplayer@.13,playerposx@.13,playerposy@.13,playerposz@.13
		E3DSetDir hsidplayer@.13,playerdirx@.13,playerdiry@.13,playerdirz@.13
		E3DSetMotionKind hsidplayer@.13,fluida_stand@
		E3DSetNewPose hsidplayer@.13,framenoplayer@.13
		playermovecnt@.13 = 0
		repeat 30
		dfcnt = cnt
			repeat 30
			pathmatrix@.0.cnt.dfcnt = blockgroup@.cnt.dfcnt
			loop
		loop
		pathmatrixset dfstage,0,0
		E3DInitParticle ptlid1@

		playerkindonstage@.16 = 6
		playerposx@.16 = groundx0@ + 700.0 * 2.0 + 350.0 : playerposy@.16 = groundy@ : playerposz@.16 = groundz0@ + 700.0 * 26.0 + 350.0
		playerdirx@.16 = 0.0 : playerdiry@.16 = 0.0 : playerdirz@.16 = 0.0
		E3DSetPos hsidplayer@.16,playerposx@.16,playerposy@.16,playerposz@.16
		E3DSetDir hsidplayer@.16,playerdirx@.16,playerdiry@.16,playerdirz@.16
		E3DSetMotionKind hsidplayer@.16,gelsol0_walk@
		E3DSetNewPose hsidplayer@.16,framenoplayer@.16
		playermovecnt@.16 = rnd(3) * 30 + 50
	swbreak
	case 10
		pathbuf@.0 = mediadir@ + "\\blockx10z2.sig"
		E3DSigLoad pathbuf@.0, hsidblock@.0,0,7.0
		E3DSigLoad pathbuf@.0, hsidblock@.1,0,7.0
		pathbuf@.0 = mediadir@ + "\\blockx4z5.sig"
		repeat 3,2
		E3DSigLoad pathbuf@.0, hsidblock@.cnt,0,7.0
		loop
		pathbuf@.0 = mediadir@ + "\\blockx1z20.sig"
		repeat 2,5
		E3DSigLoad pathbuf@.0, hsidblock@.cnt,0,7.0
		loop
		pathbuf@.0 = mediadir@ + "\\blockx2z10.sig"
		E3DSigLoad pathbuf@.0, hsidblock@.7,0,7.0
		pathbuf@.0 = mediadir@ + "\\blockx10z2.sig"
		E3DSigLoad pathbuf@.0, hsidblock@.8,0,7.0
		pathbuf@.0 = mediadir@ + "\\blocklx23456z5.sig"
		E3DSigLoad pathbuf@.0, hsidblock@.9,0,7.0
		pathbuf@.0 = mediadir@ + "\\blocklx65432z5.sig"
		E3DSigLoad pathbuf@.0, hsidblock@.10,0,7.0
		pathbuf@.0 = mediadir@ + "\\blockrx23456z5.sig"
		E3DSigLoad pathbuf@.0, hsidblock@.11,0,7.0
		pathbuf@.0 = mediadir@ + "\\blockrx65432z5.sig"
		E3DSigLoad pathbuf@.0, hsidblock@.12,0,7.0
		pathbuf@.0 = mediadir@ + "\\blockx10z2.sig"
		E3DSigLoad pathbuf@.0, hsidblock@.13,0,7.0
		pathbuf@.0 = mediadir@ + "\\blockx2z10.sig"
		E3DSigLoad pathbuf@.0, hsidblock@.14,0,7.0
		pathbuf@.0 = mediadir@ + "\\blockx4z5.sig"
		repeat 3,15
		E3DSigLoad pathbuf@.0, hsidblock@.cnt,0,7.0
		loop
		pathbuf@.0 = mediadir@ + "\\blockx10z2.sig"
		E3DSigLoad pathbuf@.0, hsidblock@.18,0,7.0
		E3DSigLoad pathbuf@.0, hsidblock@.19,0,7.0
		
		setblockparam 0,Bx10z2,1,26
		setblockparam 1,Bx10z2,11,26
		setblockparam 2,Bx4z5,4,21
		setblockparam 3,Bx4z5,21,24
		setblockparam 4,Bx4z5,25,24
		setblockparam 5,Bx1z20,1,6
		setblockparam 6,Bx1z20,28,4
		setblockparam 7,Bx2z10,8,16
		setblockparam 8,Bx10z2,18,18
		setblockparam 9,Blx23456z5,9,15
		setblockparam 10,Blx65432z5,9,10
		setblockparam 11,Brx23456z5,15,15
		setblockparam 12,Brx65432z5,15,10
		setblockparam 13,Bx10z2,2,10
		setblockparam 14,Bx2z10,20,4
		setblockparam 15,Bx4z5,1,1
		setblockparam 16,Bx4z5,5,1
		setblockparam 17,Bx4z5,22,4
		setblockparam 18,Bx10z2,9,2
		setblockparam 19,Bx10z2,19,2

		
		E3DSetPos hsidbodypart@.dfstage,groundx0@ + 700.0 * 1.0 + 350.0,groundy@,groundz0@ + 700.0 * 1.0 + 350.0
		E3DSetDir hsidbodypart@.dfstage,0.0,0.0,0.0

		E3DSetMaterialAlpha hsidplayer@.0,-1,1.0
		E3DSetMotionKind hsidplayer@.0,player_stand
		E3DSetNewPose hsidplayer@.0,framenoplayer@.0
		playerposx@.0 = groundx0@ + 700.0 * 28.0 + 350.0 : playerposy@.0 = groundy@ : playerposz@.0 = groundz0@ + 700.0 * 2.0 + 350.0
		playerdirx@.0 = 0.0 : playerdiry@.0 = 0.0 : playerdirz@.0 = 0.0
		E3DSetPos hsidplayer@.0,playerposx@.0,playerposy@.0,playerposz@.0
		E3DSetDir hsidplayer@.0,playerdirx@.0,playerdiry@.0,playerdirz@.0

		playerkindonstage@.7 = 3
		playerposx@.7 = groundx0@ + 700.0 * 13.0 + 350.0 : playerposy@.7 = groundy@ : playerposz@.7 = groundz0@ + 700.0 * 17.0 + 350.0
		playerdirx@.7 = 0.0 : playerdiry@.7 = 0.0 : playerdirz@.7 = 0.0
		E3DSetPos hsidplayer@.7,playerposx@.7,playerposy@.7,playerposz@.7
		E3DSetDir hsidplayer@.7,playerdirx@.7,playerdiry@.7,playerdirz@.7
		E3DSetMotionKind hsidplayer@.7,hdefencea_stand@
		E3DSetNewPose hsidplayer@.7,framenoplayer@.7
		playermovecnt@.7 = 50

		playerkindonstage@.10 = 4
		playerposx@.10 = groundx0@ + 700.0 * 28.0 + 350.0 : playerposy@.10 = groundy@ : playerposz@.10 = groundz0@ + 700.0 * 19.0 + 350.0
		playerdirx@.10 = 0.0 : playerdiry@.10 = 0.0 : playerdirz@.10 = 0.0
		E3DSetPos hsidplayer@.10,playerposx@.10,playerposy@.10,playerposz@.10
		E3DSetDir hsidplayer@.10,playerdirx@.10,playerdiry@.10,playerdirz@.10
		E3DSetMotionKind hsidplayer@.10,hdefenceb_normal@
		E3DSetNewPose hsidplayer@.10,framenoplayer@.10
		playermovecnt@.10 = 0

		playerkindonstage@.13 = 5
		playerposx@.13 = groundx0@ + 700.0 * 1.0 + 350.0 : playerposy@.13 = groundy@ : playerposz@.13 = groundz0@ + 700.0 * 27.0 + 350.0
		playerdirx@.13 = 0.0 : playerdiry@.13 = 0.0 : playerdirz@.13 = 0.0
		E3DSetPos hsidplayer@.13,playerposx@.13,playerposy@.13,playerposz@.13
		E3DSetDir hsidplayer@.13,playerdirx@.13,playerdiry@.13,playerdirz@.13
		E3DSetMotionKind hsidplayer@.13,fluida_stand@
		E3DSetNewPose hsidplayer@.13,framenoplayer@.13
		playermovecnt@.13 = 0
		repeat 30
		dfcnt = cnt
			repeat 30
			pathmatrix@.0.cnt.dfcnt = blockgroup@.cnt.dfcnt
			loop
		loop
		pathmatrixset dfstage,0,0
		E3DInitParticle ptlid1@

		playerkindonstage@.16 = 6
		playerposx@.16 = groundx0@ + 700.0 * 5.0 + 350.0 : playerposy@.16 = groundy@ : playerposz@.16 = groundz0@ + 700.0 * 4.0 + 350.0
		playerdirx@.16 = 0.0 : playerdiry@.16 = 0.0 : playerdirz@.16 = 0.0
		E3DSetPos hsidplayer@.16,playerposx@.16,playerposy@.16,playerposz@.16
		E3DSetDir hsidplayer@.16,playerdirx@.16,playerdiry@.16,playerdirz@.16
		E3DSetMotionKind hsidplayer@.16,gelsol0_walk@
		E3DSetNewPose hsidplayer@.16,framenoplayer@.16
		playermovecnt@.16 = rnd(3) * 30 + 50

		playerkindonstage@.17 = 6
		playerposx@.17 = groundx0@ + 700.0 * 23.0 + 350.0 : playerposy@.17 = groundy@ : playerposz@.17 = groundz0@ + 700.0 * 25.0 + 350.0
		playerdirx@.17 = 0.0 : playerdiry@.17 = 0.0 : playerdirz@.17 = 0.0
		E3DSetPos hsidplayer@.17,playerposx@.17,playerposy@.17,playerposz@.17
		E3DSetDir hsidplayer@.17,playerdirx@.17,playerdiry@.17,playerdirz@.17
		E3DSetMotionKind hsidplayer@.17,gelsol0_walk@
		E3DSetNewPose hsidplayer@.17,framenoplayer@.17
		playermovecnt@.17 = rnd(3) * 30 + 50
	swbreak
	swend

	
	setgroundtexture dfstage / 6
	E3DSetMotionKind hsidg0@,g0rb_ouen@
	E3DSetNewPose hsidg0@,framenog0@
	E3DSetMotionKind hsidg1@,g1rb_ouen@
	E3DSetNewPose hsidg1@,framenog1@
	repeat 10
	if cnt = dfstage : break
	E3DSetPos hsidbodypart@.cnt,-7000.0 + cnt * 1500.0,groundy@,12000.0
	E3DSetDir hsidbodypart@.cnt,0.0,0.0,0.0
	loop
	return

#deffunc setblockparam int blockno,int blocktype,int bpx,int bpz
	E3DSetPos hsidblock@.blockno,groundx0@ + 700.0 * bpx,0.0,groundz0@ + 700.0 * bpz
	repeat 20
	E3DSetScale hsidblock@.blockno,cnt + 2,1.0,1.0,1.0,2
	loop
	switch blocktype
	case Bx20z1
		repeat 20
		blockstate@.(bpx + cnt).bpz = 100
		blockgroup@.(bpx + cnt).bpz = 0
		blocktoobjpart@.(bpx + cnt).bpz = 100 * hsidblock@.blockno + 2 + cnt
		loop
	swbreak
	case Bx2z10
		repeat 20
		blockstate@.(bpx + cnt \ 2).(bpz + 9 - cnt / 2) = 100
		blockgroup@.(bpx + cnt \ 2).(bpz + 9 - cnt / 2) = 0
		blocktoobjpart@.(bpx + cnt \ 2).(bpz + 9 - cnt / 2) = 100 * hsidblock@.blockno + 2 + cnt
		loop
	swbreak
	case Bx1z20
		repeat 20
		blockstate@.bpx.(bpz + 19 - cnt) = 100
		blockgroup@.bpx.(bpz + 19 - cnt) = 0
		blocktoobjpart@.bpx.(bpz + 19 - cnt) = 100 * hsidblock@.blockno + 2 + cnt
		loop
	swbreak
	case Bx4z5
		repeat 20
		blockstate@.(bpx + cnt \ 4).(bpz + 4 - cnt / 4) = 100
		blockgroup@.(bpx + cnt \ 4).(bpz + 4 - cnt / 4) = 0
		blocktoobjpart@.(bpx + cnt \ 4).(bpz + 4 - cnt / 4) = 100 * hsidblock@.blockno + 2 + cnt
		loop
	swbreak
	case Bx10z2
		repeat 20
		blockstate@.(bpx + cnt \ 10).(bpz + 1 - cnt / 10) = 100
		blockgroup@.(bpx + cnt \ 10).(bpz + 1 - cnt / 10) = 0
		blocktoobjpart@.(bpx + cnt \ 10).(bpz + 1 - cnt / 10) = 100 * hsidblock@.blockno + 2 + cnt
		loop
	swbreak
	case Blx23456z5
		repeat 20
		if (cnt >= 0)and(cnt <= 1){
			bpx1 = bpx + 4 + cnt
			bpz1 = bpz + 4
		}
		if (cnt >= 2)and(cnt <= 4){
			bpx1 = bpx + 3 + cnt - 2
			bpz1 = bpz + 3
		}
		if (cnt >= 5)and(cnt <= 8){
			bpx1 = bpx + 2 + cnt - 5
			bpz1 = bpz + 2
		}
		if (cnt >= 9)and(cnt <= 13){
			bpx1 = bpx + 1 + cnt - 9
			bpz1 = bpz + 1
		}
		if cnt >= 14{
			bpx1 = bpx + cnt - 14
			bpz1 = bpz
		}
		blockstate@.bpx1.bpz1 = 100
		blockgroup@.bpx1.bpz1 = 0
		blocktoobjpart@.bpx1.bpz1 = 100 * hsidblock@.blockno + 2 + cnt
		loop
	swbreak
	case Blx65432z5
		repeat 20
		if (cnt >= 0)and(cnt <= 5){
			bpx1 = bpx + cnt
			bpz1 = bpz + 4
		}
		if (cnt >= 6)and(cnt <= 10){
			bpx1 = bpx + 1 + cnt - 6
			bpz1 = bpz + 3
		}
		if (cnt >= 11)and(cnt <= 14){
			bpx1 = bpx + 2 + cnt - 11
			bpz1 = bpz + 2
		}
		if (cnt >= 15)and(cnt <= 17){
			bpx1 = bpx + 3 + cnt - 15
			bpz1 = bpz + 1
		}
		if cnt >= 18{
			bpx1 = bpx + 4 + cnt - 18
			bpz1 = bpz
		}
		blockstate@.bpx1.bpz1 = 100
		blockgroup@.bpx1.bpz1 = 0
		blocktoobjpart@.bpx1.bpz1 = 100 * hsidblock@.blockno + 2 + cnt
		loop
	swbreak
	case Brx23456z5
		repeat 20
		if (cnt >= 0)and(cnt <= 1){
			bpx1 = bpx + cnt
			bpz1 = bpz + 4
		}
		if (cnt >= 2)and(cnt <= 4){
			bpx1 = bpx + cnt - 2
			bpz1 = bpz + 3
		}
		if (cnt >= 5)and(cnt <= 8){
			bpx1 = bpx + cnt - 5
			bpz1 = bpz + 2
		}
		if (cnt >= 9)and(cnt <= 13){
			bpx1 = bpx + cnt - 9
			bpz1 = bpz + 1
		}
		if cnt >= 14{
			bpx1 = bpx + cnt - 14
			bpz1 = bpz
		}
		blockstate@.bpx1.bpz1 = 100
		blockgroup@.bpx1.bpz1 = 0
		blocktoobjpart@.bpx1.bpz1 = 100 * hsidblock@.blockno + 2 + cnt
		loop
	swbreak
	case Brx65432z5
		repeat 20
		if (cnt >= 0)and(cnt <= 5){
			bpx1 = bpx + cnt
			bpz1 = bpz + 4
		}
		if (cnt >= 6)and(cnt <= 10){
			bpx1 = bpx + cnt - 6
			bpz1 = bpz + 3
		}
		if (cnt >= 11)and(cnt <= 14){
			bpx1 = bpx + cnt - 11
			bpz1 = bpz + 2
		}
		if (cnt >= 15)and(cnt <= 17){
			bpx1 = bpx + cnt - 15
			bpz1 = bpz + 1
		}
		if cnt >= 18{
			bpx1 = bpx + cnt - 18
			bpz1 = bpz
		}
		blockstate@.bpx1.bpz1 = 100
		blockgroup@.bpx1.bpz1 = 0
		blocktoobjpart@.bpx1.bpz1 = 100 * hsidblock@.blockno + 2 + cnt
		loop
	swbreak
	swend
	return
	
#deffunc blockconflict
	switch int(playerdiry@.0)
	case 0
	case 180
		repeat 30
		dfcnt = cnt
			repeat 30
			if blockstate@.cnt.dfcnt ! 100 : continue
			dfposxa = groundx0@ + 700.0 * cnt
			dfposxb = groundx0@ + 700.0 + 700.0 * cnt
			if playerposx@.0 <= dfposxb{
				if dfposxa <= playerposx@.0 : blockstate@.cnt.dfcnt = 99 : blockgroup@.cnt.dfcnt = -1
			}
			else{
				;if blockgroup@.cnt.dfcnt ! -1 : blockgroup@.cnt.dfcnt++
			}
			loop
		loop
	swbreak
	case 90
	case 270
		repeat 30
		dfcnt = cnt
		dfposza = groundz0@ + 700.0 * dfcnt
		dfposzb = groundz0@ + 700.0 + 700.0 * dfcnt
			repeat 30
			if blockstate@.cnt.dfcnt ! 100 : continue
			if playerposz@.0 <= dfposzb{
				if dfposza <= playerposz@.0 : blockstate@.cnt.dfcnt = 99 : blockgroup@.cnt.dfcnt = -1
			}
			else{
				;if blockgroup@.cnt.dfcnt ! -1 : blockgroup@.cnt.dfcnt++
			}
			loop
		loop
	swbreak
	case 45
	case 225
		repeat 30
		dfcnt = cnt
		dfposza = groundz0@ + 700.0 * dfcnt
		dfposzb = groundz0@ + 700.0 + 700.0 * dfcnt
			repeat 30
			if blockstate@.cnt.dfcnt ! 100 : continue
			nseppen = playerposz@.0 - playerposx@.0
			dfposxa = groundx0@ + 700.0 * cnt
			dfposxb = groundx0@ + 700.0 + 700.0 * cnt
			if dfposzb >= dfposxa + nseppen{
				if dfposxb + nseppen >= dfposza : blockstate@.cnt.dfcnt = 99 : blockgroup@.cnt.dfcnt = -1
			}
			else{
				;if blockgroup@.cnt.dfcnt ! -1 : blockgroup@.cnt.dfcnt++
			}
			loop
		loop
	swbreak
	case 135
	case 315
		repeat 30
		dfcnt = cnt
		dfposza = groundz0@ + 700.0 * dfcnt
		dfposzb = groundz0@ + 700.0 + 700.0 * dfcnt
			repeat 30
			if blockstate@.cnt.dfcnt ! 100 : continue
			nseppen = playerposz@.0 + playerposx@.0
			dfposxa = groundx0@ + 700.0 * cnt
			dfposxb = groundx0@ + 700.0 + 700.0 * cnt
			if -dfposxb + nseppen <= dfposzb{
				if dfposza <= -dfposxa + nseppen : blockstate@.cnt.dfcnt = 99 : blockgroup@.cnt.dfcnt = -1
			}
			else{
				;if blockgroup@.cnt.dfcnt ! -1 : blockgroup@.cnt.dfcnt++
			}
			loop
		loop
	swbreak
	swend
	return

#deffunc blockconflict1 int playercnt
	blkx0 = int(playerposx@.playercnt - groundx0@) / 700
	blkz0 = int(playerposz@.playercnt - groundz0@) / 700
	blkx = blkx0
	blkz = blkz0 - 2
	if (blkx >= 0)and(blkx <= 29)and(blkz >= 0)and(blkz <= 29) : blockstate@.blkx.blkz = 99 : blockgroup@.blkx.blkz = -1
	blkx = blkx0 - 1
	blkz = blkz0 - 1
	repeat 3
	if (blkx >= 0)and(blkx <= 29)and(blkz >= 0)and(blkz <= 29) : blockstate@.blkx.blkz = 99 : blockgroup@.blkx.blkz = -1
	blkx++
	loop
	blkx = blkx0 - 2
	blkz = blkz0
	repeat 5
	if (blkx >= 0)and(blkx <= 29)and(blkz >= 0)and(blkz <= 29) : blockstate@.blkx.blkz = 99 : blockgroup@.blkx.blkz = -1
	blkx++
	loop
	blkx = blkx0 - 1
	blkz = blkz0 + 1
	repeat 3
	if (blkx >= 0)and(blkx <= 29)and(blkz >= 0)and(blkz <= 29) : blockstate@.blkx.blkz = 99 : blockgroup@.blkx.blkz = -1
	blkx++
	loop
	blkx = blkx0
	blkz = blkz0 + 2
	if (blkx >= 0)and(blkx <= 29)and(blkz >= 0)and(blkz <= 29) : blockstate@.blkx.blkz = 99 : blockgroup@.blkx.blkz = -1
	return

#deffunc groupingblock
	igroup = 1
	repeat
	if igroup > groupnomax : break
	ichangegroup = 0
		repeat 30
		dfcnt = cnt
			repeat 30 
			if blockgroup@.cnt.dfcnt = igroup : blockgroup@.cnt.dfcnt = groupnomax + 1 : ichangegroup++
			loop
		loop
	if ichangegroup > 0 : groupnomax += 2
	igroup += 2
	loop
	return

#deffunc alittleblockdown
	repeat Maxngroup
	blocknosum@.cnt = 0
	loop
	
	igroup = 0
	repeat
		repeat 30
		dfcnt = cnt
			repeat 30 
			if blockgroup@.cnt.dfcnt = igroup : blocknosum@.igroup += 1
			loop
		loop
	igroup++
	if igroup > groupnomax : break
	loop
	
	repeat Maxngroup
	if cnt > groupnomax : break
	if blocknosum@.cnt >= 10 : continue
	igroup = cnt
	blocknosum@.igroup = 0
		repeat 30
		dfcnt = cnt
			repeat 30
			if blockgroup@.cnt.dfcnt = igroup : blockgroup@.cnt.dfcnt = -1 : blockstate@.cnt.dfcnt = 99
			loop
		loop
	loop

	igroup = -2
	repeat
	igroup += 2
	if igroup > groupnomax : break
	if blocknosum@.igroup > 0 : continue
		repeat 30
		dfcnt = cnt
			repeat 30 
			if blockgroup@.cnt.dfcnt = groupnomax - 1 : blockgroup@.cnt.dfcnt = igroup
			loop
		loop
	groupnomax -= 2
	loop
	return

#deffunc alittleblockdown1
	groupnum1 = 1
	repeat
	groupingblock1 groupnum1
	group0num = 0
		repeat 30
		dfcnt = cnt
			repeat 30 
			if blockgroup@.cnt.dfcnt = 0 : group0num++
			loop
		loop
	if group0num = 0 : break : else : groupnum1++
	loop

	repeat Maxngroup
	blocknosum@.cnt = 0
	loop
	
	igroup = 0
	repeat
		repeat 30
		dfcnt = cnt
			repeat 30 
			if blockgroup@.cnt.dfcnt = igroup : blocknosum@.igroup += 1
			loop
		loop
	igroup++
	if igroup > groupnum1 : break
	loop
	
	repeat Maxngroup
	if cnt > groupnum1 : break
	if blocknosum@.cnt >= 10 : continue
	igroup = cnt
	blocknosum@.igroup = 0
		repeat 30
		dfcnt = cnt
			repeat 30
			if blockgroup@.cnt.dfcnt = igroup : blockgroup@.cnt.dfcnt = -1 : blockstate@.cnt.dfcnt = 99
			loop
		loop
	loop

	repeat 30
	dfcnt = cnt
		repeat 30 
		if blockgroup@.cnt.dfcnt ! -1 : blockgroup@.cnt.dfcnt = 0
		loop
	loop	
	return
	
#deffunc groupingblock1 int distinguishgroup
	repeatbreak = 0
	repeat 30
	dfcnt = cnt
		repeat 30 
		if blockgroup@.cnt.dfcnt = 0 : blockgroup@.cnt.dfcnt = distinguishgroup : repeatbreak = 1 : break
		loop
	if repeatbreak = 1 : break
	loop

	repeat
	changegroup = 0
		repeat 30
		dfcnt = cnt
			repeat 30 
			if blockgroup@.cnt.dfcnt = 0{
				if cnt > 0 : if blockgroup@.(cnt - 1).dfcnt = distinguishgroup : blockgroup@.cnt.dfcnt = distinguishgroup : changegroup++
				if dfcnt > 0 : if blockgroup@.cnt.(dfcnt - 1) = distinguishgroup : blockgroup@.cnt.dfcnt = distinguishgroup : changegroup++
				if cnt < 29 : if blockgroup@.(cnt + 1).dfcnt = distinguishgroup : blockgroup@.cnt.dfcnt = distinguishgroup : changegroup++
				if dfcnt < 29 : if blockgroup@.cnt.(dfcnt + 1) = distinguishgroup : blockgroup@.cnt.dfcnt = distinguishgroup : changegroup++
			}
			if blockgroup@.cnt.dfcnt = distinguishgroup{
				if cnt > 0 : if blockgroup@.(cnt - 1).dfcnt = 0 : blockgroup@.(cnt - 1).dfcnt = distinguishgroup : changegroup++
				if dfcnt > 0 : if blockgroup@.cnt.(dfcnt - 1) = 0 : blockgroup@.cnt.(dfcnt - 1) = distinguishgroup : changegroup++
				if cnt < 29 : if blockgroup@.(cnt + 1).dfcnt = 0 : blockgroup@.(cnt + 1).dfcnt = distinguishgroup : changegroup++
				if dfcnt < 29 : if blockgroup@.cnt.(dfcnt + 1) = 0 : blockgroup@.cnt.(dfcnt + 1) = distinguishgroup : changegroup++
			}
			loop
		loop
	if changegroup = 0 : break
	loop
	return

#deffunc blockdown
	repeat 30
		dfcnt = cnt
		repeat 30
		if blocktoobjpart@.cnt.dfcnt = -1 : continue
		if (blockstate@.cnt.dfcnt >= 2)and(blockstate@.cnt.dfcnt < 100){
			E3DSetScale (blocktoobjpart@.cnt.dfcnt) / 100,(blocktoobjpart@.cnt.dfcnt) \ 100,1.0,0.01 * blockstate@.cnt.dfcnt,1.0,2
			blockstate@.cnt.dfcnt -= 1
		}
		loop
	loop
	return

#deffunc testfilewrite
	ililne = 0
	savedatastr@ = "blockstate"
	noteadd savedatastr@,ililne,1
	ililne++
	
	repeat 30
	dfcnt = 29 - cnt
	savedatastr@ = ""
		repeat 30
		savedatastr@ += strf("%4d",blockstate@.cnt.dfcnt) + ";"
		loop
		noteadd savedatastr@,ililne,1
		ililne++
	loop
	
	savedatastr@ = "blocktoobjpart"
	noteadd savedatastr@,ililne,1
	ililne++
	
	repeat 30
	dfcnt = 29 - cnt
	savedatastr@ = ""
		repeat 30
		savedatastr@ += strf("%4d",blocktoobjpart@.cnt.dfcnt) + ";"
		loop
		noteadd savedatastr@,ililne,1
		ililne++
	loop

	savedatastr@ = "blockgroup"
	noteadd savedatastr@,ililne,1
	ililne++
	
	repeat 30
	dfcnt = 29 - cnt
	savedatastr@ = ""
		repeat 30
		savedatastr@ += strf("%4d",blockgroup@.cnt.dfcnt) + ";"
		loop
		noteadd savedatastr@,ililne,1
		ililne++
	loop

	savedatastr@ = "hsidblock"
	noteadd savedatastr@,ililne,1
	ililne++
	
	savedatastr@ = ""
	repeat 20
	savedatastr@ += str(hsidblock@.cnt) + ";"
	if cnt \ 10 = 9{
		noteadd savedatastr@,ililne,1
		ililne++
		savedatastr@ = ""
	}
	loop

	savedatastr@ = "hsidblockpos"
	noteadd savedatastr@,ililne,1
	ililne++
	
	savedatastr@ = ""
	repeat 20
	E3DGetPos hsidblock@.cnt,tempposx@,tempposy@,tempposz@
	savedatastr@ += str(cnt) + ";" + strf("%5.1f ;",tempposx@) + strf("%5.1f ;",tempposy@) + strf("%5.1f ;",tempposz@)
	noteadd savedatastr@,ililne,1
	ililne++
	savedatastr@ = ""
	loop

	savedatastr@ = "pathmatrix"
	noteadd savedatastr@,ililne,1
	ililne++
	
	repeat 30
	dfcnt = 29 - cnt
	savedatastr@ = ""
		repeat 30
		savedatastr@ += strf("%4d",pathmatrix@.1.cnt.dfcnt) + ";"
		loop
		noteadd savedatastr@,ililne,1
		ililne++
	loop
	
	notesave "testprint.txt"
	return

#deffunc checkcharagroundy int dfplayerno
	if dfplayerno = 0{
		E3DGetVertPos hsidplayer@.0,12,29,dfposx0,dfposy0,dfposz0,1
		dfposy0 = groundy@ * 0.01 * fromposxztoblocky(dfposx0,dfposz0)
		E3DGetVertPos hsidplayer@.0,12,468,dfposx1,dfposy1,dfposz1,1
		dfposy1 = groundy@ * 0.01 * fromposxztoblocky(dfposx1,dfposz1)
		E3DGetVertPos hsidplayer@.0,13,32,dfposxa,dfposya,dfposza,1
		dfposya = groundy@ * 0.01 * fromposxztoblocky(dfposxa,dfposza)
		E3DGetVertPos hsidplayer@.0,13,473,dfposxb,dfposyb,dfposzb,1
		dfposyb = groundy@ * 0.01 * fromposxztoblocky(dfposxb,dfposzb)
		tempposy@ = dfposy0
		if tempposy@ < dfposy1 : tempposy@ = dfposy1
		if tempposy@ < dfposya : tempposy@ = dfposya
		if tempposy@ < dfposyb : tempposy@ = dfposyb
	}
	else{
		tempposy@ = groundy@ * 0.01 * fromposxztoblocky(playerposx@.dfplayerno,playerposz@.dfplayerno)
	}
	return 

#deffunc checkpartsgroundy int dfpartsno
	if dfplayerno = 0{
		E3DGetVertPos hsidplayer@.0,12,29,dfposx0,dfposy0,dfposz0,1
		dfposy0 = groundy@ * 0.01 * fromposxztoblocky(dfposx0,dfposz0)
		E3DGetVertPos hsidplayer@.0,12,468,dfposx1,dfposy1,dfposz1,1
		dfposy1 = groundy@ * 0.01 * fromposxztoblocky(dfposx1,dfposz1)
		E3DGetVertPos hsidplayer@.0,13,32,dfposxa,dfposya,dfposza,1
		dfposya = groundy@ * 0.01 * fromposxztoblocky(dfposxa,dfposza)
		E3DGetVertPos hsidplayer@.0,13,473,dfposxb,dfposyb,dfposzb,1
		dfposyb = groundy@ * 0.01 * fromposxztoblocky(dfposxb,dfposzb)
		tempposy@ = dfposy0
		if tempposy@ < dfposy1 : tempposy@ = dfposy1
		if tempposy@ < dfposya : tempposy@ = dfposya
		if tempposy@ < dfposyb : tempposy@ = dfposyb
	}
	else{
		tempposy@ = groundy@ * 0.01 * fromposxztoblocky(playerposx@.dfplayerno,playerposz@.dfplayerno)
	}
	return 

#defcfunc fromposxztoblocky double useposx,double useposz
	blkx = int(useposx - groundx0@) / 700
	blkz = int(useposz - groundz0@) / 700
	if blkx < 0 : return 0.0
	if blkx > 29 : return 0.0
	if blkz < 0 : return 0.0
	if blkz > 29 : return 0.0
	return blockstate@.blkx.blkz

#defcfunc standblockscaley int bowhsid
	blocki@ = int(playerposx@.bowhsid - groundx0@) / 700
	blockj@ = int(playerposz@.bowhsid - groundz0@) / 700
	return blockstate@.blocki@.blockj@

#deffunc spritedivisiondraw int dfspid,int dfcell,int trax1,int tray1
	startu = 0.15625 * (dfcell \ 6)
	endu = 0.15625 + 0.15625 * (dfcell \ 6)
	startv = 0.15625 * (dfcell / 6)
	endv = 0.15625 + 0.15625 * (dfcell / 6)
	E3DSetSpriteUV dfspid,startu,endu,startv,endv
	E3DRenderSprite dfspid,1.0,1.0,trax1,tray1,0.0
	return

#deffunc spritemojiback int dfmjback,int trax2,int tray2
	if dfmjback = 0{
		startu = 0.0
		endu = 0.97656
		startv = 0.0
		endv = 0.390625
		E3DSetSpriteUV spidmojiback1@,startu,endu,startv,endv
		E3DRenderSprite spidmojiback1@,1.0,1.0,trax2,tray2,0.0
	}
	else{
		startu = 0.0
		endu = 0.3125
		startv = 0.46875
		endv = 0.77344
		E3DSetSpriteUV spidmojiback1@,startu,endu,startv,endv
		E3DRenderSprite spidmojiback1@,1.0,1.0,trax2,tray2,0.0
	}
	return

#defcfunc charatateyokoonaji int tyocharano
	blkx = int(playerposx@.tyocharano - groundx0@) / 700
	blkz = int(playerposz@.tyocharano - groundz0@) / 700
	blkx0 = int(playerposx@.0 - groundx0@) / 700
	blkz0 = int(playerposz@.0 - groundz0@) / 700
	if blkx = blkx0{
		if playerposz@.tyocharano > playerposz@.0 : return 0 : else : return 4
	}
	if blkz = blkz0{
		if playerposx@.tyocharano > playerposx@.0 : return 2 : else : return 6
	}
	return -1

#defcfunc fromdegytoxzrad double dfdeg
	return (1.5 - dfdeg / 180.0) * M_PI

#defcfunc fromxzradtodegy double dfrad
	return (270.0 - dfrad * 180.0 / M_PI)

#defcfunc myangleradian double x0ar,double z0ar,double x1ar,double z1ar
	if x0ar ! x1ar{
		return atan(z1ar - z0ar,x1ar - x0ar)
	}
	else{
		if z1ar > z0ar : return M_PI * 0.5 : else : return -M_PI * 0.5
	}

#defcfunc dist2pxz double xd0,double zd0,double xd1,double zd1
	return sqrt((xd1 - xd0) * (xd1 - xd0) + (zd1 - zd0) * (zd1 - zd0))
	
#deffunc hdefencebfwrddir int hdefencebno
	repeat 4
	blkx1 = int(playerposx@.hdefencebno + 2850.0 * cos(fromdegytoxzrad(playerdiry@.hdefencebno)))
	blkz1 = int(playerposz@.hdefencebno + 2850.0 * sin(fromdegytoxzrad(playerdiry@.hdefencebno)))
	blkscale = fromposxztoblocky(blkx1,blkz1)
	if blkscale = 100{
		break
	}
	else{
		playerdiry@.hdefencebno += 90.0
	}
	loop
	return

#deffunc setgroundtexture int groundkind
	repeat 20
	E3DSetTextureToMaterial hsidblock@.cnt,0,texidfielda@ + groundkind
	loop
	return

#deffunc pathmatrixset int dfstage1,int fluidno,int destkind
	if destkind = 0{
		E3DGetPos hsidbodypart@.dfstage1,tempposx@,tempposy@,tempposz@
		destx = int(tempposx@ - groundx0@) / 700
		destz = int(tempposz@ - groundz0@) / 700
	}
	else{
		destx = int(playerposx@.0 - groundx0@) / 700
		destz = int(playerposz@.0 - groundz0@) / 700
	}	
	startx = int(playerposx@.(13 + fluidno) - groundx0@) / 700
	startz = int(playerposz@.(13 + fluidno) - groundz0@) / 700
	pathmatrix@.fluidno.destx.destz = 1
	checknum = 1
	result = 0
	repeat
	changecnt = 0
		repeat 30
		dfcnt = cnt
			repeat 30
			if pathmatrix@.fluidno.cnt.dfcnt = -1 : continue
			if pathmatrix@.fluidno.cnt.dfcnt = checknum{
				if (cnt > 0)and(pathmatrix@.fluidno.(cnt - 1).dfcnt = 0){
					pathmatrix@.fluidno.(cnt - 1).dfcnt = checknum + 1
					changecnt++
					if (cnt - 1 = startx)and(dfcnt = startz) : result = checknum + 1 : break
				}
				if (cnt < 29)and(pathmatrix@.fluidno.(cnt + 1).dfcnt = 0){
					pathmatrix@.fluidno.(cnt + 1).dfcnt = checknum + 1
					changecnt++
					if (cnt + 1 = startx)and(dfcnt = startz) : result = checknum + 1 : break
				}
				if (dfcnt > 0)and(pathmatrix@.fluidno.cnt.(dfcnt - 1) = 0){
					pathmatrix@.fluidno.cnt.(dfcnt - 1) = checknum + 1
					changecnt++
					if (cnt = startx)and(dfcnt - 1 = startz) : result = checknum + 1 : break
				}
				if (dfcnt < 29)and(pathmatrix@.fluidno.cnt.(dfcnt + 1) = 0){
					pathmatrix@.fluidno.cnt.(dfcnt + 1) = checknum + 1
					changecnt++
					if (cnt = startx)and(dfcnt + 1= startz) : result = checknum + 1 : break
				}
			}
			loop
		if result > 0 : break
		loop
	if changecnt = 0{
		if destkind = 0 : playermovecnt@.(13 + fluidno) = 1
		if destkind = 1 : playermovecnt@.(13 + fluidno) = 2
		break
	}
	if result > 0 : break : else : checknum++
	loop
	if changecnt ! 0{
		fluiddestset fluidno,result,startx,startz
		if destkind = 1 : playermovecnt@.(13 + fluidno) = 1
	}
	return

#deffunc fluiddestset int fluidno1,int pathnum,int nowblkx,int nowblkz
	if pathmatrix@.fluidno1.(nowblkx - 1).nowblkz = pathnum - 1{
		value10000x100z@.fluidno1 = (pathnum - 1) * 10000 + (nowblkx - 1) * 100 + nowblkz
		return
	}
	if pathmatrix@.fluidno1.(nowblkx + 1).nowblkz = pathnum - 1{
		value10000x100z@.fluidno1 = (pathnum - 1) * 10000 + (nowblkx + 1) * 100 + nowblkz
		return
	}
	if pathmatrix@.fluidno1.nowblkx.(nowblkz - 1) = pathnum - 1{
		value10000x100z@.fluidno1 = (pathnum - 1) * 10000 + nowblkx * 100 + nowblkz - 1
		return
	}
	if pathmatrix@.fluidno1.nowblkx.(nowblkz + 1) = pathnum - 1{
		value10000x100z@.fluidno1 = (pathnum - 1) * 10000 + nowblkx * 100 + nowblkz + 1
		return
	}
	value10000x100z@.fluidno1 = -1
	return

#deffunc forfluidapathcalc int dfstage2
	repeat 3
	if playerkindonstage@.(cnt + 13) = -1 : continue
	dfcnt1 = cnt
		repeat 30
		dfcnt = cnt
			repeat 30
			pathmatrix@.dfcnt1.cnt.dfcnt = blockgroup@.cnt.dfcnt
			loop
		loop
	pathmatrixset dfstage2,dfcnt1,0
	if playermovecnt@.(13 + dfcnt1) = 1 : pathmatrixset dfstage2,dfcnt1,1
	loop
	return

#deffunc fluidapathtoplayer int fluidno2,int dfstage3
	repeat 30
	dfcnt = cnt
		repeat 30
		pathmatrix@.fluidno2.cnt.dfcnt = blockgroup@.cnt.dfcnt
		loop
	loop
	pathmatrixset dfstage3,fluidno2,1
	
	return

#deffunc mychkconflict2 int hsida,int hsidb
	repeat 6
	E3DChkConflict2 hsida,-1, hsidb, playerpartnum@.cnt,confflagbullet@, inviewflag@
	if confflagbullet@ = 1 : break
	loop
	return

#deffunc screen0render
	E3DSetSpriteARGB spidgrey53w2h2@,limit(255 - 4 * titlecnt@,0,255),255,255,255
	E3DSetSpriteARGB spidtytlemoji2@,limit(4 * (titlecnt@ - 60),0,255),255,255,255
	E3DBeginScene scidbefore@.0
	E3DBeginSprite
	E3DRenderSprite spidmechaskinblue@, 1.0, 1.0,8,2, 0.0
	E3DRenderSprite spidmechaskinblue@, 1.0, 1.0,136,2, 0.0
	E3DRenderSprite spidmechaskinyellow@, 1.0, 1.0,264,2, 0.0
	E3DRenderSprite spidmechaskingrey@, 1.0, 1.0,8,130, 0.0
	E3DRenderSprite spidmechaskingrey@, 1.0, 1.0,136,130, 0.0
	E3DRenderSprite spidmechaskingrey@, 1.0, 1.0,264,130, 0.0
	E3DRenderSprite spidtytlemoji2@, 1.0, 1.0,0,0, 0.0
	E3DRenderSprite spidtytlemoji0@, 1.0, 1.0,0,0, 0.0
	E3DRenderSprite spidgrey53w2h2@, 200.0, 150.0,0,0, 0.0
    E3DEndSprite
	E3DEndScene
	return

#deffunc screen1render
	camposx@ = 750.0 : camposy@ = 3500.0 : camposz@ = 13300.0
	E3DSetCameraPos camposx@, camposy@, camposz@
	camtargetposx@ = 2200.0 : camtargetposy@ = 2700.0: camtargetposz@ = 15600.0
	E3DSetCameraTarget camtargetposx@,camtargetposy@,camtargetposz@,upvecx@,upvecy@,upvecz@
	proj_near@ = 100.0 : proj_far@ = 100000.0 : proj_fov@ = 30.0
	E3DSetProjection proj_near@, proj_far@, proj_fov@
	if titlecnt@ = 180{
		E3DSetMaterialAlpha hsidplayer@.0,-1,1.0
		E3DSetMotionKind hsidplayer@.0,player_stand
		E3DSetNewPose hsidplayer@.0,framenoplayer@.0
		playerposx@.0 = 3300.0 : playerposy@.0 = groundy@ : playerposz@.0 = 17700.0
		playerdirx@.0 = 0.0 : playerdiry@.0 = 0.0 : playerdirz@.0 = 0.0
		E3DSetPos hsidplayer@.0,playerposx@.0,playerposy@.0,playerposz@.0
		E3DSetDir hsidplayer@.0,playerdirx@.0,playerdiry@.0,playerdirz@.0
	}
	E3DBeginScene scidbefore@.1
	E3DSetNewPose hsidplayer@.0,framenoplayer@.0
	E3DChkInView scidbefore@.1,hsidplayer@.0
	E3DRender scidbefore@.1,hsidplayer@.0, 0,framenoplayer@.0, 0
	
	renderplantisland scidbefore@.1,myangleradian(camtargetposx@,camtargetposz@,camposx@,camposz@)
	
	E3DEndScene
	return

#deffunc screen2render
	camtargetposx@ = islandax@ + 6600.0 : camtargetposy@ = groundy@ + 1500.0: camtargetposz@ = islandaz@ + 3500.0
	camposx@ = camtargetposx@ + cameradistance * cos(cameratheta + 1.5 * M_PI) : camposy@ = groundy@ + 2500.0 : camposz@ = camtargetposz@ + cameradistance * sin(cameratheta + 1.5 * M_PI)
	E3DSetCameraPos camposx@, camposy@, camposz@
	E3DSetCameraTarget camtargetposx@,camtargetposy@,camtargetposz@,upvecx@,upvecy@,upvecz@
	proj_near@ = 100.0 : proj_far@ = 100000.0 : proj_fov@ = 30.0
	E3DSetProjection proj_near@, proj_far@, proj_fov@
	cameratheta += 0.00624
	if cameratheta = 6.24 : cameratheta = 0.0
	
	if titlecnt@ = 300{
		cameratheta = 0.0
		cameradistance = 5500.0
		E3DSetMotionKind hsidg0@,g0rb_ouen@
		E3DSetNewPose hsidg0@,framenog0@
		E3DSetPos  hsidg0@,camtargetposx@ - 1000.0,groundy@,camtargetposz@
		E3DSetDir hsidg0@,0.0,0.0,0.0
		E3DSetMotionKind hsidg1@,g1rb_ouen@
		E3DSetNewPose hsidg1@,framenog1@
		E3DSetPos  hsidg1@,camtargetposx@ + 1000.0,groundy@,camtargetposz@
		E3DSetDir hsidg1@,0.0,0.0,0.0
	}
	E3DBeginScene scidbefore@.2
	E3DSetNewPose hsidg0@,framenog0@
	E3DChkInView scidbefore@.2,hsidg0@
	E3DRender scidbefore@.2,hsidg0@, 0,framenog0@, 0
	E3DSetNewPose hsidg1@,framenog1@
	E3DChkInView scidbefore@.2,hsidg1@
	E3DRender scidbefore@.2,hsidg1@, 0,framenog1@, 0
	
	renderplantisland scidbefore@.3,cameratheta
	
	E3DEndScene
	return

#deffunc screen3render
	camtargetposx@ = 0.0 : camtargetposy@ = 0.0: camtargetposz@ = 0.0
	camposx@ = 1414.0 : camposy@ = 0.0 : camposz@ = -1414.0
	E3DSetCameraPos camposx@, camposy@, camposz@
	E3DSetCameraTarget camtargetposx@,camtargetposy@,camtargetposz@,upvecx@,upvecy@,upvecz@
	
	E3DBeginScene scidbefore@.3
	E3DBeginSprite
	E3DRenderSprite spidmenuback@, 400.0 / 128.0,300.0 / 128.0,0,0, 1.0
    E3DEndSprite
	E3DSetPos  hsidyajirusi@,-247.0,140.0 - iselect@ * 170.0,-247.0
	E3DSetDir hsidyajirusi@,0.0,-135.0,limitf(10.0 * (double(titlecnt@) - 1000.0),0.0,1200.0)
	E3DChkInView scidbefore@.3,hsidyajirusi@
	E3DRender scidbefore@.3,hsidyajirusi@, 0
	if iselect@ = 1{
		if keybuf@.VK_LEFT = 1{
			if maxstage@ = 10{
				psound0play soundid8@,0,0
				istageselect@--
				if istageselect@ = -1 : istageselect@ = 10
			}
			else{
				psound0play soundid8@,0,0
				istageselect@--
				if istageselect@ = -1 : istageselect@ = 0
			}
		}
		if keybuf@.VK_RIGHT = 1{
			if maxstage@ = 10{
				psound0play soundid8@,0,0
				istageselect@++
				if istageselect@ = 11 : istageselect@ = 0
			}
			else{
				psound0play soundid8@,0,0
				istageselect@++
				if istageselect@ > maxstage@ : istageselect@--
			}
		}
		E3DSetPos  hsidstageselect@,110.0,-300.0,-100.0
		E3DSetDir hsidstageselect@,0.0,360.0 / 11.0 * istageselect@ - 45.0,0.0
		E3DChkInView scidbefore@.3,hsidstageselect@
		E3DRender scidbefore@.3,hsidstageselect@, 0
		E3DDrawTextByFontID scidbefore@.3,fontid0@,190,190,"",255,250,250,250
		E3DDrawTextByFontID scidbefore@.3,fontid0@,100,230,"",255,250,250,250
		E3DDrawTextByFontID scidbefore@.3,fontid0@,280,230,"",255,250,250,250
	}
	
	E3DDrawTextByFontID scidbefore@.3,fontid0@,150,100,"v[O",255,250,250,250
	E3DDrawTextByFontID scidbefore@.3,fontid0@,150,150,"Q[Jn",255,250,250,250
	E3DEndScene
	return

#deffunc screen0prologue
	E3DBeginScene scidbefore@.0
	E3DDrawTextByFontIDWithCnt scidbefore@.0, fontid0@, 50, 50,"́A҃ZJCL[́A\n\n̐@邽߂ɁA\n\n{bgPbgłグ\n\n̂łB", 255, 250, 250, 250,4,curcnt
	curcnt++
	E3DEndScene
	return

#deffunc screen1prologue
	camtargetposx@ = 0.0 : camtargetposy@ = 0.0: camtargetposz@ = 0.0
	camposx@ = 0.0 : camposy@ = 0.0 : camposz@ = -7000.0
	E3DSetCameraPos camposx@, camposy@, camposz@
	E3DSetCameraTarget camtargetposx@,camtargetposy@,camtargetposz@,upvecx@,upvecy@,upvecz@
	
	randomize 1
	
	E3DBeginScene scidbefore@.1
	E3DBeginSprite
	repeat 50
	E3DRenderSprite spidhosi1@ + rnd(2), 0.3,0.3,rnd(50) * 8,rnd(50) * 6, 1.0
	loop
	E3DRenderSprite spidnebula@, 1.0,1.0,200,200, 0.999
	E3DRenderSprite spidhosi1@, 0.8,0.8,limit(((prologuecnt@ - 300) \ 80) * 6,0,400),100, 0.99
	E3DRenderSprite spidhosi2@, 0.6,0.6,limit(((prologuecnt@ - 300) \ 100) * 5,0,400),250, 0.99
	E3DRenderSprite spidhosi1@, 0.7,0.7,limit(((prologuecnt@ - 300) \ 120) * 4,0,400),200, 0.99
	E3DRenderSprite spidhosi2@, 0.5,0.5,limit(((prologuecnt@ - 300) \ 160) * 3,0,400),270, 0.99
    E3DEndSprite

    E3DSetPos hsidegg0@,-500.0,0.0,0.0
	E3DSetDir hsidegg0@,0.0,0.0,90.0
	E3DSetValidFlag hsidegg0@, 5,0
	E3DSetValidFlag hsidegg0@, 6,0
	E3DSetPos hsidegg3@,1300.0,0.0,0.0
	E3DSetDir hsidegg3@,0.0,0.0,90.0
	E3DSetValidFlag hsidegg3@, 5,0
	E3DSetValidFlag hsidegg3@, 6,0
	E3DChkInView scidbefore@.1,hsidegg0@
	E3DRender scidbefore@.1,hsidegg0@, 0,0, 0
	E3DChkInView scidbefore@.1,hsidegg3@
	E3DRender scidbefore@.1,hsidegg3@, 0,0, 0
	E3DEndScene
	return

#deffunc screen2prologue
	camposx@ = 750.0 : camposy@ = 3500.0 : camposz@ = 13300.0
	E3DSetCameraPos camposx@, camposy@, camposz@
	camtargetposx@ = 2200.0 : camtargetposy@ = 2700.0: camtargetposz@ = 15600.0
	E3DSetCameraTarget camtargetposx@,camtargetposy@,camtargetposz@,upvecx@,upvecy@,upvecz@
	
	E3DBeginScene scidbefore@.2
	if prologuecnt@ < 760{
		E3DSetValidFlag hsidegg0@, 5,1
		E3DSetValidFlag hsidegg0@, 6,1
		E3DSetPos hsidegg0@,3300.0,limitf(1000.0 + groundy@ - 10.0 * (prologuecnt@ - 600.0),groundy@,1000.0 + groundy@),17700.0
		E3DSetDir hsidegg0@,0.0,0.0,0.0
		E3DChkInView scidbefore@.2,hsidegg0@
		E3DRender scidbefore@.2,hsidegg0@, 0,0, 0
	}
	else{
		E3DSetPos hsidsmkk00@,3300.0,groundy@,17700.0
		E3DSetDir hsidsmkk00@,0.0,0.0,0.0
		E3DSetNewPose hsidsmkk00@,framenosmkk00@
		E3DChkInView scidbefore@.2,hsidsmkk00@
		E3DRender scidbefore@.2,hsidsmkk00@, 0,framenosmkk00@, 0
	}
	renderplantisland scidbefore@.2,myangleradian(camtargetposx@,camtargetposz@,camposx@,camposz@)

	if prologuecnt@ < 700 : E3DRender scidbefore@.2,hsidegg0@, 1,0, 0
	if (prologuecnt@ >= 700)and(prologuecnt@ < 820){
		alpha = 255.0 * sin((double(prologuecnt@) - 700.0) * M_PI / 120.0)
		E3DBeginSprite
		E3DSetSpriteARGB spidpehikari@,int(alpha),255,255,255
		E3DRenderSprite spidpehikari@, 0.5,0.5,121,95, 0.0
		E3DEndSprite
	}
	E3DEndScene

	return

#deffunc screen3prologue
	camposx@ = -3600.0 : camposy@ = 3500.0 : camposz@ = 14800.0
	E3DSetCameraPos camposx@, camposy@, camposz@
	camtargetposx@ = -2150.0 : camtargetposy@ = 2700.0: camtargetposz@ = 17100.0
	E3DSetCameraTarget camtargetposx@,camtargetposy@,camtargetposz@,upvecx@,upvecy@,upvecz@

	E3DBeginScene scidbefore@.3
	if prologuecnt@ < 1060{
		E3DSetValidFlag hsidegg3@, 5,1
		E3DSetValidFlag hsidegg3@, 6,1
		E3DSetPos hsidegg3@,-1050.0,limitf(1000.0 + groundy@ - 10.0 * (prologuecnt@ - 900.0),groundy@,1000.0 + groundy@),19200.0
		E3DSetDir hsidegg3@,0.0,0.0,0.0
		E3DChkInView scidbefore@.3,hsidegg3@
		E3DRender scidbefore@.3,hsidegg3@, 0,0, 0
	}
	else{
		randomize 2
		repeat 10
		E3DSetPos hsidbodypart@.cnt,-1050.0 + 10.0 * (prologuecnt@ - 1060.0) * double(rnd(11) - 5),groundy@ + 10.0 * (prologuecnt@ - 1060.0),19200.0 + 20.0 * (prologuecnt@ - 1060.0) * double(rnd(11) - 5)
		E3DSetDir hsidbodypart@.cnt,0.0,0.0,0.0
		E3DChkInView scidbefore@.3,hsidbodypart@.cnt
		E3DRender scidbefore@.3,hsidbodypart@.cnt, 0,0, 0
		loop
		if prologuecnt@ < 1180{
			E3DSetPos hsids3head@,-1050.0,groundy@ + 800.0 * sin((double(prologuecnt@) - 1060.0) * M_PI / 120.0),19200.0
		}
		else{
			E3DSetPos hsids3head@,-1050.0,groundy@ ,19200.0
		}
		E3DSetDir hsids3head@,0.0,0.0,0.0
		E3DChkInView scidbefore@.3,hsids3head@
		E3DRender scidbefore@.3,hsids3head@, 0,0, 0
		E3DSetPos hsids3migiudete@,-1050.0 + 15.0 * (prologuecnt@ - 1060.0),groundy@+ 20.0 * (prologuecnt@ - 1000.0),19200.0 - 15.0 * (prologuecnt@ - 1060.0)
		E3DSetDir hsids3migiudete@,0.0,0.0,0.0
		E3DChkInView scidbefore@.3,hsids3migiudete@
		E3DRender scidbefore@.3,hsids3migiudete@, 0,0, 0
		
	}

	renderplantisland scidbefore@.3,myangleradian(camtargetposx@,camtargetposz@,camposx@,camposz@)
	if prologuecnt@ < 1000 : E3DRender scidbefore@.3,hsidegg3@, 1,0, 0
	if (prologuecnt@ >= 1000)and(prologuecnt@ < 1120){
		alpha = 255.0 * sin((double(prologuecnt@) - 1000.0) * M_PI / 120.0)
		E3DBeginSprite
		E3DSetSpriteARGB spidpehikari@,int(alpha),255,255,255
		E3DRenderSprite spidpehikari@, 0.5,0.5,121,95, 0.0
		E3DEndSprite
	}
	if prologuecnt@ > 1400{
		E3DDrawTextByFontID scidbefore@.3,fontid0@,200,270,"EnterŎ",255,250,250,250
		if keybuf@.VK_RETURN >= 1{
			psound0play soundid8@,0,0
			prologuepage@ = 1
			prologuecnt@ = -1
		}
	}
	E3DEndScene
	
	return
	
#deffunc renderplantisland int dfscid,double dfcameratheta
	repeat 5
	E3DSetNewPose hsidplant0@.cnt,framenoplant0@.cnt
	E3DChkInView dfscid,hsidplant0@.cnt
	E3DRender dfscid,hsidplant0@.cnt, 0,framenoplant0@.cnt, 0
	loop
	repeat 10
	E3DSetNewPose hsidplant1@.cnt,framenoplant1@.cnt
	E3DChkInView dfscid,hsidplant1@.cnt
	E3DRender dfscid,hsidplant1@.cnt, 0,framenoplant1@.cnt, 0
	loop
	E3DChkInView dfscid,hsidfield@
	E3DRender dfscid,hsidfield@, 0

	matr@ = int(50.0 * cos(0.0261 * cnt240@) + 100.0)
	matg@ = int(50.0 * cos(0.0261 * cnt240@) + 100.0)
	matb@ = 250
	E3DSetMaterialEmissive hsidwatersurface@,0,0,matr@,matg@,matb@
	E3DSetPos  hsidwatersurface@,500.0 * cos(0.0261 * cnt240@),0.5 * groundy@,0.0
	E3DSetDir hsidwatersurface@,0.0,fromxzradtodegy(dfcameratheta),0.0
	E3DChkInView scidbefore@.2,hsidwatersurface@
	E3DRender scidbefore@.2,hsidwatersurface@, 0
	return

#defcfunc getstageclearno
	noteload "stageclear.txt"
	noteget savedatastr@,0
	split savedatastr@,";",forloadstr@
	return int(forloadstr@.0)

#deffunc screen0ending
	E3DSetMotionKind hsidsmkk03rbt@,smkk03rbt_gattai@
	repeat 242 + limit(endingcnt@,0,60)
	E3DSetNewPose hsidsmkk03rbt@,framenosmkk03rbt@
	loop
	
	camposx@ = 1000.0 : camposy@ = groundy@ + 700.0 : camposz@ = 16500.0
	E3DSetCameraPos camposx@, camposy@, camposz@
	camtargetposx@ = 1000.0 : camtargetposy@ = groundy@ + 200.0 : camtargetposz@ = 19000.0
	E3DSetCameraTarget camtargetposx@,camtargetposy@,camtargetposz@,upvecx@,upvecy@,upvecz@
	
	E3DBeginScene scidbefore@.0
	E3DChkInView scidbefore@.0,hsidsmkk03rbt@
	E3DRender scidbefore@.0,hsidsmkk03rbt@, 0,framenosmkk03rbt@, 0
	renderplantisland scidbefore@.3,myangleradian(camtargetposx@,camtargetposz@,camposx@,camposz@)
	E3DEndScene
	return

#deffunc screen1ending
	E3DSetMotionKind hsidsmkk03rbt@,smkk03rbt_gattai@
	repeat 302 + limit(endingcnt@ - 120,0,60)
	E3DSetNewPose hsidsmkk03rbt@,framenosmkk03rbt@
	loop
	
	camposx@ = 1000.0 : camposy@ = groundy@ + 2000.0 : camposz@ = 21000.0
	E3DSetCameraPos camposx@, camposy@, camposz@
	camtargetposx@ = 1000.0 : camtargetposy@ = groundy@ + 1500.0 : camtargetposz@ = 19000.0
	E3DSetCameraTarget camtargetposx@,camtargetposy@,camtargetposz@,upvecx@,upvecy@,upvecz@
	
	E3DBeginScene scidbefore@.1
	E3DChkInView scidbefore@.1,hsidsmkk03rbt@
	E3DRender scidbefore@.1,hsidsmkk03rbt@, 0,framenosmkk03rbt@, 0
	renderplantisland scidbefore@.1,myangleradian(camtargetposx@,camtargetposz@,camposx@,camposz@)
	E3DEndScene
	return

#deffunc screen2ending
	E3DSetMotionKind hsidsmkk03rbt@,smkk03rbt_gattai@
	repeat 362 + limit(endingcnt@ - 180,0,60)
	E3DSetNewPose hsidsmkk03rbt@,framenosmkk03rbt@
	loop
	
	camposx@ = 1500.0 : camposy@ = groundy@ + 1900.0 : camposz@ = 17000.0
	E3DSetCameraPos camposx@, camposy@, camposz@
	camtargetposx@ = 1300.0 : camtargetposy@ = groundy@ + 1600.0 : camtargetposz@ = 19000.0
	E3DSetCameraTarget camtargetposx@,camtargetposy@,camtargetposz@,upvecx@,upvecy@,upvecz@
	
	E3DBeginScene scidbefore@.2
	E3DChkInView scidbefore@.2,hsidsmkk03rbt@
	E3DRender scidbefore@.2,hsidsmkk03rbt@, 0,framenosmkk03rbt@, 0
	renderplantisland scidbefore@.2,myangleradian(camtargetposx@,camtargetposz@,camposx@,camposz@)
	E3DEndScene
	return

#deffunc screen3ending
	E3DSetMotionKind hsidsmkk03rbt@,smkk03rbt_gattai@
	repeat 422 + limit(endingcnt@ - 240,0,60)
	E3DSetNewPose hsidsmkk03rbt@,framenosmkk03rbt@
	loop
	
	camposx@ = 500.0 : camposy@ = groundy@ + 2000.0 : camposz@ = 16000.0
	E3DSetCameraPos camposx@, camposy@, camposz@
	camtargetposx@ = 1000.0 : camtargetposy@ = groundy@ + 1600.0 : camtargetposz@ = 19000.0
	E3DSetCameraTarget camtargetposx@,camtargetposy@,camtargetposz@,upvecx@,upvecy@,upvecz@
	
	E3DBeginScene scidbefore@.3
	E3DChkInView scidbefore@.3,hsidsmkk03rbt@
	E3DRender scidbefore@.3,hsidsmkk03rbt@, 0,framenosmkk03rbt@, 0
	renderplantisland scidbefore@.3,myangleradian(camtargetposx@,camtargetposz@,camposx@,camposz@)
	E3DEndScene
	return

#global
	screen 0, 800,600, 0,0,0
	title "{bgƃ{bg(withƌ)"
	E3DInit 0, -1, 0, 16, 0, scid1
	E3DCreateFont 20, 0, 600, 0, 0, 0, "lr SVbN", fontid0
	E3DCreateFont 40, 0, 600, 0, 0, 0, "lr SVbN", fontid1
	E3DCreateFont 10, 0, 400, 0, 0, 0, "lr ", fontid2
	E3DSetClearCol scid1, 255,53,53,53
	E3DBeginScene scid1
	strchk = "LOADING"
	E3DGetStrSizeByFontID fontid0,strchk, strwidth, strheight
	E3DDrawTextByFontID scid1,fontid0,(800 - strwidth) / 2,290,strchk,255,250,250,250
	;E3DDrawTextByFontID scid1,fontid1,180,130,"@",255,250,250,250
	;E3DDrawTextByFontID scid1,fontid1,580,130,"A",255,250,250,250
	;E3DDrawTextByFontID scid1,fontid1,180,430,"B",255,250,250,250
	;E3DDrawTextByFontID scid1,fontid1,580,430,"C",255,250,250,250
	E3DEndScene
	E3DPresent scid1
	
	lightdirx1 = -1.0
	lightdiry1 = -1.0
	lightdirz1 = 1.0
	lightr1 = 255
	lightg1 = 255
	lightb1 = 255
	E3DCreateLight lid1
	E3DSetDirectionalLight lid1, lightdirx1, lightdiry1, lightdirz1, lightr1, lightg1, lightb1
	
	upvecx = 0.0 : upvecy = 1.0 : upvecz = 0.0
	
	chkfps1 = 0

	groundx0 = -10500.0
	groundz0 = -10500.0
	groundx1 = 10499.9
	groundz1 = 10499.9
	groundy = 1400.0
	camerastep = 100.0
	cameradegstep = 0.01

	dim keybuf, 256
	pathlen = 2048
	sdim mediadir, pathlen
	mediadir = dir_cur + "\\MEDIA"
	sdim pathbuf, pathlen,2

	pathbuf.0 = mediadir + "\\islanda.mqo"
	E3DLoadMQOFileAsGround pathbuf.0,7.0,hsidfield,0
	E3DSetDir hsidfield,0.0,0.0,0.0
	islandax = -7000.0
	islandaz = 10500.0
	E3DSetPos hsidfield,islandax,0.0,islandaz
	dim hsidplant0,5
	dim framenoplant0,5
	pathbuf.0 = mediadir + "\\plant0.sig"
	pathbuf.1 = mediadir + "\\plant0_stand.qua"
	repeat 5
	E3DSigLoad pathbuf.0,hsidplant0(cnt),0,2.0
	E3DAddMotion hsidplant0(cnt), pathbuf.1,plant0_stand, maxplant0_stand
	E3DSetMotionKind hsidplant0(cnt),plant0_stand
	E3DSetDir hsidplant0(cnt),0.0,72.0 * cnt,0.0
	loop
	E3DSetPos  hsidplant0(0),islandax + 3000.0,groundy,islandaz + 8200.0
	E3DSetPos  hsidplant0(1),islandax + 6000.0,groundy,islandaz + 4400.0
	E3DSetPos  hsidplant0(2),islandax + 1500.0,groundy,islandaz + 3700.0
	E3DSetPos  hsidplant0(3),islandax + 12200.0,groundy,islandaz + 6500.0
	E3DSetPos  hsidplant0(4),islandax + 9700.0,groundy,islandaz + 9200.0
	dim hsidplant1,10
	dim framenoplant1,10
	pathbuf.0 = mediadir + "\\plant1.sig"
	pathbuf.1 = mediadir + "\\plant1_stand.qua"
	repeat 10
	E3DSigLoad pathbuf.0,hsidplant1(cnt)
	E3DAddMotion hsidplant1(cnt), pathbuf.1,plant1_stand, maxplant1_stand
	E3DSetMotionKind hsidplant1(cnt),plant1_stand
	E3DSetDir hsidplant1(cnt),0.0,36.0 * cnt,0.0
	loop
	E3DSetPos  hsidplant1(0),islandax + 2000.0,groundy,islandaz + 7500.0
	E3DSetPos  hsidplant1(1),islandax + 4100.0,groundy,islandaz + 4300.0
	E3DSetPos  hsidplant1(2),islandax + 6100.0,groundy,islandaz + 6000.0
	E3DSetPos  hsidplant1(3),islandax + 8500.0,groundy,islandaz + 4700.0
	E3DSetPos  hsidplant1(4),islandax + 10000.0,groundy,islandaz + 5600.0
	E3DSetPos  hsidplant1(5),islandax + 10000.0,groundy,islandaz + 8900.0
	E3DSetPos  hsidplant1(6),islandax + 7900.0,groundy,islandaz + 10000.0
	E3DSetPos  hsidplant1(7),islandax + 6000.0,groundy,islandaz + 10500.0
	E3DSetPos  hsidplant1(8),islandax + 4900.0,groundy,islandaz + 9800.0
	E3DSetPos  hsidplant1(9),islandax + 7100.0,groundy,islandaz + 6000.0
	
	pathbuf.0 = mediadir + "\\yajirusirobot.sig"
	E3DSigLoad pathbuf.0,hsidyajirusi,0.0,0.2
	pathbuf.0 = mediadir + "\\stageselect.sig"
	E3DSigLoad pathbuf.0,hsidstageselect,0.0,2.0
	
	pathbuf.0 = mediadir + "\\g0roborobo.sig"
	E3DSigLoad pathbuf.0, hsidg0
	pathbuf.1 = mediadir + "\\g0rb_ouen.qua"
	E3DAddMotion hsidg0, pathbuf.1,g0rb_ouen, maxg0rb_ouen
	pathbuf.1 = mediadir + "\\g0rb_indexf.qua"
	E3DAddMotion hsidg0, pathbuf.1,g0rb_indexf, maxg0rb_indexf
	pathbuf.1 = mediadir + "\\g0rb_search.qua"
	E3DAddMotion hsidg0, pathbuf.1,g0rb_search, maxg0rb_search
	pathbuf.1 = mediadir + "\\g0rb_putarm.qua"
	E3DAddMotion hsidg0, pathbuf.1,g0rb_putarm, maxg0rb_putarm
	pathbuf.1 = mediadir + "\\g0rb_ending.qua"
	E3DAddMotion hsidg0, pathbuf.1,g0rb_ending, maxg0rb_ending
	E3DSetPos  hsidg0,-1000.0,groundy,10800.0
	E3DSetDir hsidg0,0.0,0.0,0.0
	pathbuf.0 = mediadir + "\\g1roborobo.sig"
	E3DSigLoad pathbuf.0, hsidg1
	pathbuf.1 = mediadir + "\\g1rb_ouen.qua"
	E3DAddMotion hsidg1, pathbuf.1,g1rb_ouen, maxg1rb_ouen
	pathbuf.1 = mediadir + "\\g1rb_lookat.qua"
	E3DAddMotion hsidg1, pathbuf.1,g1rb_lookat, maxg1rb_lookat
	pathbuf.1 = mediadir + "\\g1rb_givesjn.qua"
	E3DAddMotion hsidg1, pathbuf.1,g1rb_givesjn, maxg1rb_givesjn
	pathbuf.1 = mediadir + "\\g1rb_ending.qua"
	E3DAddMotion hsidg1, pathbuf.1,g1rb_ending, maxg1rb_ending
	E3DSetPos  hsidg1,1000.0,groundy,10800.0
	E3DSetDir hsidg1,0.0,0.0,0.0
	repeat 6,8
	E3DSetValidFlag hsidg1,cnt,0
	loop

	pathbuf.0 = mediadir + "\\smkk00.sig"
	E3DSigLoad pathbuf.0, hsidsmkk00
	pathbuf.1 = mediadir + "\\smkk00_stand.qua"
	E3DAddMotion hsidsmkk00, pathbuf.1,smkk00_stand, maxsmkk00_stand
	pathbuf.1 = mediadir + "\\smkk00_walk.qua"
	E3DAddMotion hsidsmkk00, pathbuf.1,smkk00_walk, maxsmkk00_walk
	pathbuf.1 = mediadir + "\\smkk00_ending.qua"
	E3DAddMotion hsidsmkk00, pathbuf.1,smkk00_ending, maxsmkk00_ending

	pathbuf.0 = mediadir + "\\smkk03rbt.sig"
	E3DSigLoad pathbuf.0, hsidsmkk03rbt
	pathbuf.1 = mediadir + "\\smkk03rbt_gattai.qua"
	E3DAddMotion hsidsmkk03rbt, pathbuf.1,smkk03rbt_gattai, maxsmkk03rbt_gattai
	pathbuf.0 = mediadir + "\\smkk03.sig"
	E3DSigLoad pathbuf.0, hsidsmkk03
	pathbuf.1 = mediadir + "\\smkk03_ending.qua"
	E3DAddMotion hsidsmkk03, pathbuf.1,smkk03_ending, maxsmkk03_ending
	
	pathbuf.0 = mediadir + "\\watersurface.sig"
	E3DSigLoad pathbuf.0, hsidwatersurface,0,50.0
	E3DSetPos  hsidwatersurface,0.0,0.5 * groundy,0.0
	E3DSetDir hsidwatersurface,0.0,0.0,0.0
	
	dim hsidblock,20
	dim blockstate,30,30
	dim blocktoobjpart,30,30
	dim blockgroup,30,30
	dim blocknosum,Maxngroup
	
	
	pathbuf.0 = mediadir + "\\attackeffect.sig"
	E3DSigLoad pathbuf.0, hsidattackeffect,0,10.0
	E3DSetMaterialBlendingMode hsidattackeffect,0,101
	E3DSetScale hsidattackeffect,2,1.0,1.0,2.36,2
	
	dim hsidplayer,Maxnplayer
	ddim playerposx,Maxnplayer
	ddim playerposy,Maxnplayer
	ddim playerposz,Maxnplayer
	ddim playerposxbef,Maxnplayer
	ddim playerposybef,Maxnplayer
	ddim playerposzbef,Maxnplayer
	ddim playerdirx,Maxnplayer
	ddim playerdiry,Maxnplayer
	ddim playerdirz,Maxnplayer
	ddim playerforwardstep,Maxnplayer
	dim framenoplayer,Maxnplayer
	dim playermovecnt,Maxnplayer
	dim playerkindonstage,Maxnplayer
	dim playerhavepoints,Maxnplayer

	pathbuf.0 = mediadir + "\\player.sig"
	E3DSigLoad pathbuf.0, hsidplayer(0)
	pathbuf.1 = mediadir + "\\player_stand.qua"
	E3DAddMotion hsidplayer(0), pathbuf.1, player_stand, maxplayer_stand
	pathbuf.1 = mediadir + "\\player_walk.qua"
	E3DAddMotion hsidplayer(0), pathbuf.1, player_walk, maxplayer_walk
	pathbuf.1 = mediadir + "\\player_jump.qua"
	E3DAddMotion hsidplayer(0), pathbuf.1, player_jump, maxplayer_jump
	pathbuf.1 = mediadir + "\\player_attack.qua"
	E3DAddMotion hsidplayer(0), pathbuf.1, player_attack, maxplayer_attack
	playerforwardstep(0) = 80.0
	dim playerpartnum,6
	playerpartnum(0) = 2
	playerpartnum(1) = 3
	playerpartnum(2) = 10
	playerpartnum(3) = 11
	playerpartnum(4) = 12
	playerpartnum(5) = 13
	
	pathbuf.0 = mediadir + "\\gelsola.sig"
	E3DSigLoad pathbuf.0, hsidplayer(1)
	E3DSigLoad pathbuf.0, hsidplayer(2)
	E3DSigLoad pathbuf.0, hsidplayer(3)
	pathbuf.1 = mediadir + "\\gelsola_stand.qua"
	E3DAddMotion hsidplayer(1), pathbuf.1, gelsola_stand, maxgelsola_stand
	E3DAddMotion hsidplayer(2), pathbuf.1, gelsola_stand, maxgelsola_stand
	E3DAddMotion hsidplayer(3), pathbuf.1, gelsola_stand, maxgelsola_stand
	pathbuf.1 = mediadir + "\\gelsola_walk.qua"
	E3DAddMotion hsidplayer(1), pathbuf.1, gelsola_walk, maxgelsola_walk
	E3DAddMotion hsidplayer(2), pathbuf.1, gelsola_walk, maxgelsola_walk
	E3DAddMotion hsidplayer(3), pathbuf.1, gelsola_walk, maxgelsola_walk
	playerforwardstep(1) = 50.0
	playerforwardstep(2) = 50.0
	playerforwardstep(3) = 50.0
	playerhavepoints(1) = 10
	playerhavepoints(2) = 10
	playerhavepoints(3) = 10

	pathbuf.0 = mediadir + "\\gelsolb.sig"
	E3DSigLoad pathbuf.0, hsidplayer(4)
	E3DSigLoad pathbuf.0, hsidplayer(5)
	E3DSigLoad pathbuf.0, hsidplayer(6)
	pathbuf.1 = mediadir + "\\gelsolb_stand.qua"
	E3DAddMotion hsidplayer(4), pathbuf.1, gelsolb_stand, maxgelsolb_stand
	E3DAddMotion hsidplayer(5), pathbuf.1, gelsolb_stand, maxgelsolb_stand
	E3DAddMotion hsidplayer(6), pathbuf.1, gelsolb_stand, maxgelsolb_stand
	pathbuf.1 = mediadir + "\\gelsolb_walk.qua"
	E3DAddMotion hsidplayer(4), pathbuf.1, gelsolb_walk, maxgelsolb_walk
	E3DAddMotion hsidplayer(5), pathbuf.1, gelsolb_walk, maxgelsolb_walk
	E3DAddMotion hsidplayer(6), pathbuf.1, gelsolb_walk, maxgelsolb_walk
	playerforwardstep(4) = 40.0
	playerforwardstep(5) = 40.0
	playerforwardstep(6) = 40.0
	playerhavepoints(4) = 15
	playerhavepoints(5) = 15
	playerhavepoints(6) = 15

	pathbuf.0 = mediadir + "\\harddefencea.sig"
	E3DSigLoad pathbuf.0, hsidplayer(7)
	E3DSigLoad pathbuf.0, hsidplayer(8)
	E3DSigLoad pathbuf.0, hsidplayer(9)
	pathbuf.1 = mediadir + "\\hdefencea_stand.qua"
	E3DAddMotion hsidplayer(7), pathbuf.1, hdefencea_stand, maxhdefencea_stand
	E3DAddMotion hsidplayer(8), pathbuf.1, hdefencea_stand, maxhdefencea_stand
	E3DAddMotion hsidplayer(9), pathbuf.1, hdefencea_stand, maxhdefencea_stand
	pathbuf.1 = mediadir + "\\hdefencea_1walk.qua"
	E3DAddMotion hsidplayer(7), pathbuf.1, hdefencea_1walk, maxhdefencea_1walk
	E3DAddMotion hsidplayer(8), pathbuf.1, hdefencea_1walk, maxhdefencea_1walk
	E3DAddMotion hsidplayer(9), pathbuf.1, hdefencea_1walk, maxhdefencea_1walk
	pathbuf.1 = mediadir + "\\hdefencea_3walk.qua"
	E3DAddMotion hsidplayer(7), pathbuf.1, hdefencea_3walk, maxhdefencea_3walk
	E3DAddMotion hsidplayer(8), pathbuf.1, hdefencea_3walk, maxhdefencea_3walk
	E3DAddMotion hsidplayer(9), pathbuf.1, hdefencea_3walk, maxhdefencea_3walk
	pathbuf.1 = mediadir + "\\hdefencea_5walk.qua"
	E3DAddMotion hsidplayer(7), pathbuf.1, hdefencea_5walk, maxhdefencea_5walk
	E3DAddMotion hsidplayer(8), pathbuf.1, hdefencea_5walk, maxhdefencea_5walk
	E3DAddMotion hsidplayer(9), pathbuf.1, hdefencea_5walk, maxhdefencea_5walk
	pathbuf.1 = mediadir + "\\hdefencea_7walk.qua"
	E3DAddMotion hsidplayer(7), pathbuf.1, hdefencea_7walk, maxhdefencea_7walk
	E3DAddMotion hsidplayer(8), pathbuf.1, hdefencea_7walk, maxhdefencea_7walk
	E3DAddMotion hsidplayer(9), pathbuf.1, hdefencea_7walk, maxhdefencea_7walk
	playerforwardstep(7) = 70.0
	playerforwardstep(8) = 70.0
	playerforwardstep(9) = 70.0
	playerhavepoints(7) = 20
	playerhavepoints(8) = 20
	playerhavepoints(9) = 20

	pathbuf.0 = mediadir + "\\harddefenceb.sig"
	E3DSigLoad pathbuf.0, hsidplayer(10)
	E3DSigLoad pathbuf.0, hsidplayer(11)
	E3DSigLoad pathbuf.0, hsidplayer(12)
	pathbuf.1 = mediadir + "\\hdefenceb_normal.qua"
	E3DAddMotion hsidplayer(10), pathbuf.1, hdefenceb_normal, maxhdefenceb_normal
	E3DAddMotion hsidplayer(11), pathbuf.1, hdefenceb_normal, maxhdefenceb_normal
	E3DAddMotion hsidplayer(12), pathbuf.1, hdefenceb_normal, maxhdefenceb_normal
	pathbuf.1 = mediadir + "\\hdefenceb_fwrd.qua"
	E3DAddMotion hsidplayer(10), pathbuf.1, hdefenceb_fwrd, maxhdefenceb_fwrd
	E3DAddMotion hsidplayer(11), pathbuf.1, hdefenceb_fwrd, maxhdefenceb_fwrd
	E3DAddMotion hsidplayer(12), pathbuf.1, hdefenceb_fwrd, maxhdefenceb_fwrd
	playerforwardstep(10) = 50.0
	playerforwardstep(11) = 50.0
	playerforwardstep(12) = 50.0
	playerhavepoints(10) = 25
	playerhavepoints(11) = 25
	playerhavepoints(12) = 25

	pathbuf.0 = mediadir + "\\fluida.sig"
	E3DSigLoad pathbuf.0, hsidplayer(13)
	E3DSigLoad pathbuf.0, hsidplayer(14)
	E3DSigLoad pathbuf.0, hsidplayer(15)
	pathbuf.1 = mediadir + "\\fluida_stand.qua"
	E3DAddMotion hsidplayer(13), pathbuf.1, fluida_stand, maxfluida_stand
	E3DAddMotion hsidplayer(14), pathbuf.1, fluida_stand, maxfluida_stand
	E3DAddMotion hsidplayer(15), pathbuf.1, fluida_stand, maxfluida_stand
	pathbuf.1 = mediadir + "\\fluida_attack.qua"
	E3DAddMotion hsidplayer(13), pathbuf.1, fluida_attack, maxfluida_attack
	E3DAddMotion hsidplayer(14), pathbuf.1, fluida_attack, maxfluida_attack
	E3DAddMotion hsidplayer(15), pathbuf.1, fluida_attack, maxfluida_attack
	playerforwardstep(13) = 30.0
	playerforwardstep(14) = 30.0
	playerforwardstep(15) = 30.0
	playerhavepoints(13) = 30
	playerhavepoints(14) = 30
	playerhavepoints(15) = 30
	dim pathmatrix,3,30,30
	dim value10000x100z,3
	E3DSetMaterialBlendingMode hsidplayer(13),3,101
	E3DSetMaterialBlendingMode hsidplayer(14),3,101
	E3DSetMaterialBlendingMode hsidplayer(15),3,101
	pathbuf.0 = mediadir + "\\particlepink.bmp"
	E3DCreateParticle 100, pathbuf.0, 400.0, 400.0, 1, ptlid1,1,0
	E3DSetParticleGravity ptlid1, -600.0
	E3DSetParticleLife ptlid1, 1.0
	E3DSetParticleEmitNum ptlid1, 1.6
	E3DSetParticleVel0 ptlid1, -500.0, 0.0, -500.0, 500.0, 0.0, 500.0
	E3DCreateParticle 100, pathbuf.0, 400.0, 400.0, 1, ptlid2,1,0
	E3DSetParticleGravity ptlid2, -600.0
	E3DSetParticleLife ptlid2, 1.0
	E3DSetParticleEmitNum ptlid2, 1.6
	E3DSetParticleVel0 ptlid2, -500.0, 0.0, -500.0, 500.0, 0.0, 500.0
	E3DCreateParticle 100, pathbuf.0, 400.0, 400.0, 1, ptlid3,1,0
	E3DSetParticleGravity ptlid3, -600.0
	E3DSetParticleLife ptlid3, 1.0
	E3DSetParticleEmitNum ptlid3, 1.6
	E3DSetParticleVel0 ptlid3, -500.0, 0.0, -500.0, 500.0, 0.0, 500.0

	pathbuf.0 = mediadir + "\\gelsol0.sig"
	E3DSigLoad pathbuf.0, hsidplayer(16)
	E3DSigLoad pathbuf.0, hsidplayer(17)
	E3DSigLoad pathbuf.0, hsidplayer(18)
	pathbuf.1 = mediadir + "\\gelsol0_stand.qua"
	E3DAddMotion hsidplayer(16), pathbuf.1, gelsol0_stand, maxgelsol0_stand
	E3DAddMotion hsidplayer(17), pathbuf.1, gelsol0_stand, maxgelsol0_stand
	E3DAddMotion hsidplayer(18), pathbuf.1, gelsol0_stand, maxgelsol0_stand
	pathbuf.1 = mediadir + "\\gelsol0_walk.qua"
	E3DAddMotion hsidplayer(16), pathbuf.1, gelsol0_walk, maxgelsol0_walk
	E3DAddMotion hsidplayer(17), pathbuf.1, gelsol0_walk, maxgelsol0_walk
	E3DAddMotion hsidplayer(18), pathbuf.1, gelsol0_walk, maxgelsol0_walk
	pathbuf.1 = mediadir + "\\gelsol0_shot.qua"
	E3DAddMotion hsidplayer(16), pathbuf.1, gelsol0_shot, maxgelsol0_shot
	E3DAddMotion hsidplayer(17), pathbuf.1, gelsol0_shot, maxgelsol0_shot
	E3DAddMotion hsidplayer(18), pathbuf.1, gelsol0_shot, maxgelsol0_shot
	pathbuf.1 = mediadir + "\\gelsol0_beam.qua"
	E3DAddMotion hsidplayer(16), pathbuf.1, gelsol0_beam, maxgelsol0_beam
	E3DAddMotion hsidplayer(17), pathbuf.1, gelsol0_beam, maxgelsol0_beam
	E3DAddMotion hsidplayer(18), pathbuf.1, gelsol0_beam, maxgelsol0_beam
	playerforwardstep(16) = 30.0
	playerforwardstep(17) = 30.0
	playerforwardstep(18) = 30.0
	playerhavepoints(16) = 35
	playerhavepoints(17) = 35
	playerhavepoints(18) = 35
	dim hsidbullet0,3,5
	dim bullet0state,3,5
	pathbuf.0 = mediadir + "\\bullet0.sig"
	repeat 3
	dfcnt = cnt
		repeat 5
		E3DSigLoad pathbuf.0,hsidbullet0(dfcnt,cnt)
		bullet0state(dfcnt,cnt) = -1
		loop
	loop
	dim hsidbeam0,3
	dim beam0state,3
	pathbuf.0 = mediadir + "\\beam0.sig"
	repeat 3
	E3DSigLoad pathbuf.0,hsidbeam0(cnt)
	E3DSetScale hsidbeam0(cnt),-1,1.0,1.0,1000.0,2
	E3DSetMaterialBlendingMode hsidbeam0(cnt),0,101
	beam0state(cnt) = -1
	loop
	
	dim hsidbodypart,11
	pathbuf.0 = mediadir + "\\s3hip.sig"
	E3DSigLoad pathbuf.0,hsidbodypart(0)
	pathbuf.0 = mediadir + "\\s3leftfoot.sig"
	E3DSigLoad pathbuf.0,hsidbodypart(1)
	pathbuf.0 = mediadir + "\\s3leftforearm.sig"
	E3DSigLoad pathbuf.0,hsidbodypart(2)
	pathbuf.0 = mediadir + "\\s3lefthand.sig"
	E3DSigLoad pathbuf.0,hsidbodypart(3)
	pathbuf.0 = mediadir + "\\s3leftshin.sig"
	E3DSigLoad pathbuf.0,hsidbodypart(4)
	pathbuf.0 = mediadir + "\\s3leftthigh.sig"
	E3DSigLoad pathbuf.0,hsidbodypart(5)
	pathbuf.0 = mediadir + "\\s3leftupperarm.sig"
	E3DSigLoad pathbuf.0,hsidbodypart(6)
	pathbuf.0 = mediadir + "\\s3rightfoot.sig"
	E3DSigLoad pathbuf.0,hsidbodypart(7)
	pathbuf.0 = mediadir + "\\s3rightshin.sig"
	E3DSigLoad pathbuf.0,hsidbodypart(8)
	pathbuf.0 = mediadir + "\\s3rightthigh.sig"
	E3DSigLoad pathbuf.0,hsidbodypart(9)
	pathbuf.0 = mediadir + "\\s3trunk.sig"
	E3DSigLoad pathbuf.0,hsidbodypart(10)

	pathbuf.0 = mediadir + "\\smkk00egg.sig"
	E3DSigLoad pathbuf.0, hsidegg0,0,2.0
	E3DSetMaterialBlendingMode hsidegg0,3,1
	E3DSetMaterialBlendingMode hsidegg0,4,1
	E3DSetValidFlag hsidegg0, 5,0
	E3DSetValidFlag hsidegg0, 6,0
	pathbuf.0 = mediadir + "\\smkk03egg.sig"
	E3DSigLoad pathbuf.0, hsidegg3,0,2.0
	E3DSetMaterialBlendingMode hsidegg3,4,1
	E3DSetMaterialBlendingMode hsidegg3,5,1
	E3DSetValidFlag hsidegg3, 5,0
	E3DSetValidFlag hsidegg3, 6,0

	pathbuf.0 = mediadir + "\\smkk03head.sig"
	E3DSigLoad pathbuf.0, hsids3head
	pathbuf.0 = mediadir + "\\smkk03migiteude.sig"
	E3DSigLoad pathbuf.0, hsids3migiudete

	pathbuf.0 = mediadir + "\\tatumaki.sig"
	E3DSigLoad pathbuf.0, hsidtatumaki
	
	pathbuf.0 = mediadir + "\\chara4040.bmp"
	E3DCreateSprite pathbuf.0,1,spidchara
	pathbuf.0 = mediadir + "\\mojiback.bmp"
	E3DCreateSprite pathbuf.0,0,spidmojiback
	E3DSetSpriteARGB spidmojiback,180,255,255,255
	pathbuf.0 = mediadir + "\\mojiback1.bmp"
	E3DCreateSprite pathbuf.0,1,spidmojiback1
	;E3DSetSpriteARGB spidmojiback1,125,255,255,255
	pathbuf.0 = mediadir + "\\tytlemoji0.bmp"
	E3DCreateSprite pathbuf.0,2,spidtytlemoji0,255,255,255
	E3DSetSpriteUV spidtytlemoji0,0.0,400.0 / 512.0,0.0,300.0 / 512.0
	pathbuf.0 = mediadir + "\\tytlemoji2.bmp"
	E3DCreateSprite pathbuf.0,2,spidtytlemoji2,255,0,0
	pathbuf.0 = mediadir + "\\grey53w2h2.bmp"
	E3DCreateSprite pathbuf.0,0,spidgrey53w2h2
	pathbuf.0 = mediadir + "\\@BS.bmp"
	E3DCreateSprite pathbuf.0,0,spidmechaskinblue
	pathbuf.0 = mediadir + "\\@B2.bmp"
	E3DCreateSprite pathbuf.0,0,spidmechaskinyellow
	pathbuf.0 = mediadir + "\\@B.bmp"
	E3DCreateSprite pathbuf.0,0,spidmechaskingrey
	pathbuf.0 = mediadir + "\\menuback.bmp"
	E3DCreateSprite pathbuf.0,0,spidmenuback
	pathbuf.0 = mediadir + "\\hosi1.bmp"
	E3DCreateSprite pathbuf.0,0,spidhosi1
	E3DSetBlendingMode -2,spidhosi1,1
	pathbuf.0 = mediadir + "\\hosi2.bmp"
	E3DCreateSprite pathbuf.0,0,spidhosi2
	E3DSetBlendingMode -2,spidhosi2,1
	pathbuf.0 = mediadir + "\\nebula.bmp"
	E3DCreateSprite pathbuf.0,0,spidnebula
	E3DSetBlendingMode -2,spidnebula,1
	pathbuf.0 = mediadir + "\\pehikari.bmp"
	E3DCreateSprite pathbuf.0,1,spidpehikari
	pathbuf.0 = mediadir + "\\sinario0.bmp"
	E3DCreateSprite pathbuf.0,1,spidfukidasileft
	pathbuf.0 = mediadir + "\\sinario1.bmp"
	E3DCreateSprite pathbuf.0,1,spidfukidasiright
	pathbuf.0 = mediadir + "\\attention.bmp"
	E3DCreateSprite pathbuf.0,1,spidattention
	
	dsresult = initdsound(hwnd)
	
	pathbuf.0 = mediadir + "\\gamestart.wav"
	soundid0 = initsoundbuffer(pathbuf.0)
	pathbuf.0 = mediadir + "\\playerjump.wav"
	soundid1 = initsoundbuffer(pathbuf.0)
	pathbuf.0 = mediadir + "\\playerattack.wav"
	soundid2 = initsoundbuffer(pathbuf.0)
	pathbuf.0 = mediadir + "\\stageback0.wav"
	soundid3 = initsoundbuffer(pathbuf.0)
	pathbuf.0 = mediadir + "\\gameclear.wav"
	soundid4 = initsoundbuffer(pathbuf.0)
	pathbuf.0 = mediadir + "\\playerout.wav"
	soundid5 = initsoundbuffer(pathbuf.0)
	pathbuf.0 = mediadir + "\\player1up.wav"
	soundid6 = initsoundbuffer(pathbuf.0)
	pathbuf.0 = mediadir + "\\stageback1.wav"
	soundid7 = initsoundbuffer(pathbuf.0)
	pathbuf.0 = mediadir + "\\keypush.wav"
	soundid8 = initsoundbuffer(pathbuf.0)
	
	pathbuf.0 = mediadir + "\\btlfield0a.bmp"
	E3DCreateTexture pathbuf.0, D3DPOOL_DEFAULT, 0, texidfielda
	pathbuf.0 = mediadir + "\\btlfield0b.bmp"
	E3DCreateTexture pathbuf.0, D3DPOOL_DEFAULT, 0, texidfieldb
	
	E3DCreateQ myqid

	dim getpointsx,5
	dim getpointsy,5
	dim getpointscnt,5
	dim getpointsvalue,5
	
	sdim savedatanote,4096
	sdim savedatastr,128
	sdim forloadstr,20,22
	notesel savedatanote

	dim scidbefore,4
	dim texidbefore,4
	repeat 4
	E3DCreateRenderTargetTexture 400,300,scidbefore(cnt),texidbefore(cnt), okflag, D3DFMT_A8R8G8B8
	if okflag = 0 : goto *bye
	loop

	dim spid,4
	pathbuf = mediadir + "\\dummy256.png"
	repeat 4
	E3DCreateSprite pathbuf, 0, spid(cnt)
	E3DSetTextureToDispObj -2, spid(cnt),texidbefore(cnt)
	loop

	
